/* 
 * EDOMI beta (Version 1.53) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
function app1020_drawMask(winId) {
	var maskdata=document.getElementById(winId+"-fd3").value.split(",");
	var n="";
	if (maskdata[1]>0 && maskdata[2]>0) {
		n+="<table width='100%' height='100%' border='0' cellpadding='0' cellspacing='0' style='border-collapse:collapse; font-size:1px;'>";
		for (var y=0; y<maskdata[2]; y++) {
			n+="<tr>";
			for (var x=0; x<maskdata[1]; x++) {
				var id=x+(y*maskdata[1]);
				if (maskdata[3].substr(0,1)=="!") {
					if (maskdata[5].substr(id,1)=="1") {
						n+="<td onClick='app1020_toggleMask(\""+winId+"\","+id+",this);' data-value='1' style='border:1px solid #a0a0a0; background:rgba(80,255,0,0.5);'>&nbsp;</td>";
					} else {
						n+="<td onClick='app1020_toggleMask(\""+winId+"\","+id+",this);' data-value='0' style='border:1px solid #a0a0a0; background:#"+maskdata[3].substr(1,6)+";'>&nbsp;</td>";
					}
				} else {
					if (maskdata[5].substr(id,1)=="1") {
						n+="<td onClick='app1020_toggleMask(\""+winId+"\","+id+",this);' data-value='1' style='border:1px solid #a0a0a0; background:#"+maskdata[3]+";'>&nbsp;</td>";
					} else {
						n+="<td onClick='app1020_toggleMask(\""+winId+"\","+id+",this);' data-value='0' style='border:1px solid #a0a0a0; background:transparent;'>&nbsp;</td>";
					}
				}
			}
			n+="</tr>";
		}
		n+="</table>";
	}
	document.getElementById(winId+"-maskedit").innerHTML=n;
}

function app1020_newMask(winId) {
	var mode=document.getElementById(winId+"-fd10").dataset.value;
	var w=document.getElementById(winId+"-fd11").dataset.value;
	var h=document.getElementById(winId+"-fd12").dataset.value;
	var color=document.getElementById(winId+"-fd13").dataset.value;
	var quality=document.getElementById(winId+"-fd14").dataset.value;
	var n="";
	for (var t=0; t<(w*h); t++) {n+="0";}
	document.getElementById(winId+"-fd3").value=mode+","+w+","+h+","+color+","+quality+","+n;
	app1020_drawMask(winId);
}

function app1020_changeMask(winId) {
	var mode=document.getElementById(winId+"-fd10").dataset.value;
	var color=document.getElementById(winId+"-fd13").dataset.value;
	var quality=document.getElementById(winId+"-fd14").dataset.value;
	var maskdata=document.getElementById(winId+"-fd3").value.split(",");
	document.getElementById(winId+"-fd3").value=mode+","+maskdata[1]+","+maskdata[2]+","+color+","+quality+","+maskdata[5];
	app1020_drawMask(winId);
}

function app1020_toggleMask(winId,id,obj) {
	var maskdata=document.getElementById(winId+"-fd3").value.split(",");
	if (obj.dataset.value=="1") {
		if (maskdata[3].substr(0,1)=="!") {obj.style.background="#"+maskdata[3].substr(1,6);} else {obj.style.background="transparent";}
		obj.dataset.value="0";
		maskdata[5]=maskdata[5].substr(0,id)+"0"+maskdata[5].substr(id+1);
	} else {
		if (maskdata[3].substr(0,1)=="!") {obj.style.background="rgba(80,255,0,0.5)";} else {obj.style.background="#"+maskdata[3];}
		obj.dataset.value="1";
		maskdata[5]=maskdata[5].substr(0,id)+"1"+maskdata[5].substr(id+1);
	}
	document.getElementById(winId+"-fd3").value=maskdata[0]+","+maskdata[1]+","+maskdata[2]+","+maskdata[3]+","+maskdata[4]+","+maskdata[5];
}

function app1020_returnMask(winId,destId) {
	//wenn kein Block maskiert ist, wird mask="" gesetzt
	var maskdata=document.getElementById(winId+"-fd3").value.split(",");
	if (maskdata[5].search("1")>=0) {
		document.getElementById(destId).value=document.getElementById(winId+"-fd3").value;
	} else {
		document.getElementById(destId).value="";
	}
	closeWindow(winId);
}
