<?
/* 
 * EDOMI beta (Version 1.53) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
//---------------------------------------------------------------------------------------------------------------------------------------------
//Elemente: Speichern
//---------------------------------------------------------------------------------------------------------------------------------------------

/*
- die Delete/Verweis-Funktionen aus app1000 in eine Include packen
- hier auch alles weitere reinmachen? z.B. Diagramm-Quellen, Szenen-Inhalte, etc...
- auch Visuelmente, etc.? (braucht der Import ja auch...)
*/



function db_itemSave($db,$data,$var1=null,$var2=null,$var3=null) {
	//$data: [1] muss immer die ID sein (-1=Insert, 1.oo=Update)
/*
	RETURN:
	1..oo: 		ID: Update oder Insert
	0/false: 	allgemeiner Fehler
	-1..-oo: 	spezieller Fehler (zur individuellen Auswertung)
*/
	global $global_dpt,$global_charttyp;

	if ($db=='editRoot') {
		//UPDATE
/*
		- data[2] (name): wenn angegeben, wird der Ordner umbenannt
		- data[3] (parentid): wenn angegeben, wird der Ordner in den Ordner mit dieser parentId verschoben
		- (data[4] (linkid): kann nicht geupdated werden)
		- data[5] (tmp): optional
*/
		if ($data[1]>0) {

			$thisFolder=sql_getValues('edomiProject.editRoot','*','id='.$data[1]);
			if ($thisFolder===false) {return 0;}

			if (isEmpty($data[2])) {$data[2]=$thisFolder['name'];}
			if (isEmpty($data[3])) {$data[3]=$thisFolder['parentid'];}

			$parentFolder=sql_getValues('edomiProject.editRoot','*','id='.$data[3]);
			if ($parentFolder===false) {return 0;}
			$rootFolder=sql_getValues('edomiProject.editRoot','*','id='.$parentFolder['rootid']);
			if ($rootFolder===false) {return 0;}
						
			//Rechte prüfen
			if (!($rootFolder['allow']&8)) {return 0;}	//Umbenennen erlaubt?
			if (!($thisFolder['rootid']==$parentFolder['rootid'] && (($thisFolder['link']==$parentFolder['link'] && $thisFolder['linkid']==$parentFolder['linkid']) || ($parentFolder['link']==0 && isEmpty($parentFolder['linkid']) && $parentFolder['id']<1000)))) {return 0;}	//Verschieben ist nur innerhalb einer rootid möglich (unter Berücksichtigung von link/linkid)
			if ($thisFolder['id']==$parentFolder['id']) {return 0;}	//Ordner in sich selbst verschoben?
			
			$dbId=sql_save('edomiProject.editRoot',$data[1],array(
				'path'			=>	"'".$parentFolder['path'].$parentFolder['id']."/'",
				'parentid'		=>	$parentFolder['id'],
				'name'			=>	"'".sql_encodeValue($data[2])."'",
				'tmp'			=>	(($data[5]>0)?$data[5]:'null')
			));
			return $dbId;

		//INSERT
/*
		- data[2] (name)
		- data[3] (parentid): der Ordner wird in dem Ordner mit dieser parentId erstellt
		- data[4] (linkid): nur erforderlich, wenn ein Ordner direkt(!) in einem Rootfolder mit allow&1 erstellt werden soll ("link" wird automatisch ermittelt)
		- data[5] (tmp): optional
*/
		} else if (!($data[1]>0) && $data[3]>0 && !isEmpty($data[2])) {
		
			$parentFolder=sql_getValues('edomiProject.editRoot','*','id='.$data[3]);
			if ($parentFolder===false) {return 0;}
			$rootFolder=sql_getValues('edomiProject.editRoot','*','id='.$parentFolder['rootid']);
			if ($rootFolder===false) {return 0;}

			//Rechte prüfen
			if (!($rootFolder['allow']&4)) {return 0;}	//Erstellen erlaubt?

			if ($parentFolder['id']<1000 && $parentFolder['allow']&1) {
				//Folder soll direkt(!) in einem vRoot erstellt werden
				$link=$parentFolder['id'];
				$linkid=$data[4];
				if (!($linkid>0 && ($linkid==$parentFolder['linkid'] || isEmpty($parentFolder['linkid'])))) {return 0;}
			} else {
				//normaler Ordner
				$link=$parentFolder['link'];
				$linkid=$parentFolder['linkid'];
			}
						
			$dbId=sql_save('edomiProject.editRoot',(($data[1]>0)?$data[1]:null),array(
				'path'			=>	"'".$parentFolder['path'].$parentFolder['id']."/'",
				'rootid'		=>	$parentFolder['rootid'],
				'parentid'		=>	$parentFolder['id'],
				'name'			=>	"'".sql_encodeValue($data[2])."'",
				'namedb'		=>	sql_encodeValue($parentFolder['namedb'],true),
				'link'			=>	(($link>0)?$link:0),
				'linkid'		=>	sql_encodeValue($linkid,true),
				'tmp'			=>	(($data[5]>0)?$data[5]:'null')
			));
			return $dbId;
		}
	}

	if ($db=='editLogicElementDef') {	//### nur für INSERT in app1000 (nicht geeignet für Import!)
		if ($data[2]>0 && !isEmpty($data[3]) && !isEmpty($data[4]) && is_numeric($data[4]) && $data[4]>=0) {

			$rootFolderId=dbRoot_getRootId($data[2]);
			$lbsId=strval(sprintf("%02d",$rootFolderId)).strval(sprintf("%06d",$data[4]));
			
			if (!($data[1]>0) && $lbsId>=12000000 && $lbsId<=19999999) {			
				//INSERT
				$lbsFn=MAIN_PATH.'/www/admin/lbs/'.$lbsId.'_lbs.php';
				if (!file_exists($lbsFn)) {
					if (file_exists(MAIN_PATH.'/www/admin/lbs/LBSVorlage'.$data[5].'.php')) {
						//Vorlage kopieren
						$vorlage=file_get_contents(MAIN_PATH.'/www/admin/lbs/LBSVorlage'.$data[5].'.php');
						$f=fopen($lbsFn,'w');
						fwrite($f,$vorlage);
						fclose($f);
						
						lbs_import($lbsId,$data[2]);
						return $lbsId;
					}
				}
			}
		}
	}

	if ($db=='editLogicElement') {
		//Hinweis: in app1 gibt es nur INSERT, bei Import auch Update!

		if ($lbsData=sql_getValues('edomiProject.editLogicElementDef','*',"id='".$data[3]."' AND errcount=0")) {

			//Update: Wurde LBS ausgetauscht?
			$changedLBS=false;
			if ($data[1]>0) {
				$lbsId_old=sql_getValue('edomiProject.editLogicElement','functionid',"id='".$data[1]."'");
				if ($lbsId_old!=$data[3]) {$changedLBS=true;}
			}
			
			$dbId=sql_save('edomiProject.editLogicElement',(($data[1]>0)?$data[1]:null),array(
				'pageid'		=>	$data[2],
				'functionid'	=>	$data[3],
				'xpos'			=>	"'".$data[4]."'",
				'ypos'			=>	"'".$data[5]."'",
				'name'			=>	sql_encodeValue($data[6],true)
			));

			if ($dbId>0) {			
				if (!($data[1]>0) || $changedLBS) {
					//Falls LBS ausgetauscht wurde: Zunächst alles löschen
					if ($changedLBS) {
						sql_call("UPDATE edomiProject.editLogicLink SET linktyp=2,linkid=null,ausgang=null WHERE (linktyp=1 AND linkid=".$dbId.")");
						sql_call("DELETE FROM edomiProject.editLogicLink WHERE elementid=".$dbId);
						sql_call("DELETE FROM edomiProject.editLogicElementVar WHERE elementid=".$dbId);
						sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE targetid=".$dbId);
					}

					//Eingänge
					$ss1=sql_call("SELECT * FROM edomiProject.editLogicElementDefIn WHERE targetid=".$lbsData['id']." ORDER BY id ASC");
					while ($n=sql_result($ss1)) {
						sql_save('edomiProject.editLogicLink',null,array(
							'elementid'	=>	$dbId,
							'linktyp'	=>	2,
							'eingang'	=>	$n['id'],
							'value'		=>	sql_encodeValue($n['value'],true)
						));
					}
					sql_close($ss1);

					//Variablen
					$ss1=sql_call("SELECT * FROM edomiProject.editLogicElementDefVar WHERE targetid=".$lbsData['id']." ORDER BY id ASC");
					while ($n=sql_result($ss1)) {
						sql_save('edomiProject.editLogicElementVar',null,array(
							'elementid'	=>	$dbId,
							'varid'		=>	$n['id'],
							'value'		=>	sql_encodeValue($n['value'],true)
						));
					}
					sql_close($ss1);
				}
			}
			return $dbId;
		}
	}

	if ($db=='editLogicCmdList' || $db=='editVisuCmdList' || $db=='editSequenceList') {
		$ok=false;
		
		if ($data[3]==1 && $data[4]>0) {$ok=true;}
		if ($data[3]==13 && $data[4]>0) {
			$data[5]=getNearestNumericValue($data[5],'0,1,2,3,11,12,13,21,22,23');
			$ok=true;
		}
		if ($data[3]==14 && $data[4]>0) {
			$data[5]=getNearestNumericValue($data[5],'0,1,2,3,11,12,13,21,22,23');
			$ok=true;
		}

		if ($data[3]==2 && $data[4]>0) {$ok=true;}
		if ($data[3]==7 && $data[4]>0 && !isEmpty($data[5])) {$ok=true;}
		if ($data[3]==3 && $data[4]>0 && $data[5]>0) {$ok=true;}
		if ($data[3]==4 && $data[4]>0 && !isEmpty($data[5])) {$ok=true;}
		if ($data[3]==6 && $data[4]>0 && $data[5]>0) {$ok=true;}
		if ($data[3]==5 && $data[4]>0) {
			$data[5]=getNearestNumericValue($data[5],'-1,1');
			$ok=true;
		}
		if ($data[3]==9 && $data[4]>0 && is_numeric($data[5]) && abs($data[5])>=1) {
			$data[5]=intval($data[5]);
			$ok=true;
		}
		if ($data[3]==8 && $data[4]>0) {$ok=true;}

		if ($data[3]==10 && $data[4]>0) {
			$data[5]=getNearestNumericValue($data[5],'0,1');
			$ok=true;
		}
		if ($data[3]==11 && $data[4]>0) {
			$data[5]=getNearestNumericValue($data[5],'0,1');
			$ok=true;
		}

		if ($data[3]==40 && $data[4]>0) {$ok=true;}
		if ($data[3]==41 && $data[4]>0) {$ok=true;}
		if ($data[3]==12 && $data[4]>0) {$ok=true;}

		if ($data[3]==50 && $data[4]>0) {
			$data[5]=getNearestNumericValue($data[5],'0,1,2');
			$ok=true;
		}
		if ($data[3]==51 && $data[4]>0) {
			$data[5]=getNearestNumericValue($data[5],'0,1,2');
			$ok=true;
		}
		if ($data[3]==52 && $data[4]>0) {
			$data[5]=getNearestNumericValue($data[5],'0,1,2');
			$ok=true;
		}
		if ($data[3]==53 && $data[4]>0) {
			$data[5]=getNearestNumericValue($data[5],'0,1,2');
			$ok=true;
		}

		if ($data[3]==15 && $data[4]>0) {$ok=true;}
		if ($data[3]==16 && $data[4]>0) {
			$data[5]=getNearestNumericValue($data[5],'1,2,3');
			$ok=true;
		}
		if ($data[3]==20 && $data[4]>0) {$ok=true;}
		if ($data[3]==22 && $data[4]>=0) {
			if (!($data[4]>0)) {$data[4]=0;}
			$data[5]=getNearestNumericValue($data[5],'0,3,5,10,15,20,30,60');
			$ok=true;
		}
		
		if ($data[3]==21 && $data[4]>0) {
			if (!($data[5]>0)) {$data[5]=0;}
			$ok=true;
		}
		if ($data[3]==28 && $data[4]>0) {
			if (!($data[5]>0)) {$data[5]=0;}
			$ok=true;
		}
		if ($data[3]==24 && $data[4]>0) {
			if (!($data[5]>0)) {$data[5]=0;}
			$ok=true;
		}
		if ($data[3]==25 && $data[4]>0) {
			if (!($data[5]>0)) {$data[5]=0;}
			$ok=true;
		}
		if ($data[3]==26 && $data[4]>0 && !isEmpty($data[5])) {$ok=true;}
		if ($data[3]==27 && $data[4]>0 && !isEmpty($data[5])) {$ok=true;}
		if ($data[3]==23) {
			if (!($data[4]>0)) {$data[4]=0;}
			if (!($data[5]>0)) {$data[5]=0;}
			$ok=true;
		}
		
		if ($data[3]==30) {
			$data[4]=getNearestNumericValue($data[4],'1,4,2,3,9');
			$ok=true;
		}


		if ($ok && $data[2]>0) {
			if ($db=='editSequenceList') {
				//bei Insert: 'sort' ggf. ermitteln (falls nicht angegeben)
				if (!($data[1]>0) && !($data[7]>=1)) {
					$max=sql_getValue('edomiProject.editSequenceList','MAX(sort)','targetid='.$data[2]);
					if ($max>0) {$data[7]=$max+1;} else {$data[7]=1;}
				}
				//zusätzliche Sequence-Eigenschaften
				$tmp=array(
					'delay'			=>	(($data[6]>0)?intval($data[6]):0),
					'sort'			=>	(($data[7]>1)?intval($data[7]):1)
				);
			} else {$tmp=array();}
			
			$dbId=sql_save('edomiProject.'.$db,(($data[1]>0)?$data[1]:null),array(
				'targetid'		=>	"'".$data[2]."'",				
				'outmode'		=>	"'".$data[3]."'",
				'outid'			=>	"'".$data[4]."'",
				'outvalue'		=>	sql_encodeValue($data[5],true)
			)+$tmp);

			return $dbId;
		}
	}

	if ($db=='editVisu') {

//### hier ist der Defaultordner eigentlich IMMER 21... (es gibt keine Subfolder für Visus)
		if (!($data[2]>0)) {$data[2]=21;}	//Defaultordner
		
		if ($data[2]>0 && !isEmpty($data[10]) && $data[4]>0 && $data[5]>0) {
			$dbId=sql_save('edomiProject.editVisu',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[10])."'",
				'xsize'			=>	"'".sql_encodeValue($data[4])."'",
				'ysize'			=>	"'".sql_encodeValue($data[5])."'",		
				'defaultpageid'	=>	sql_encodeValue($data[6],true),
				'sspageid'		=>	sql_encodeValue($data[7],true),
				'sstimeout'		=>	getNearestNumericValue($data[8],'0,1,2,3,5,10,15,20,30,45,60,120,180,300'),
				'indicolor'		=>	sql_encodeValue($data[13],true),
				'indicolor2'	=>	sql_encodeValue($data[14],true)
			));
			return $dbId;
		}
	}

	if ($db=='editVisuPage') {
		if (!($data[2]>0)) {$data[2]=22;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[4]) && $data[3]>0 && ($data[6]==0 || $data[6]==2 || ($data[6]==1 && $data[7]>0 && $data[8]>0))) {
			if ($data[6]==0) {$data[7]=null; $data[8]=null; $data[5]=0;}
			if ($data[6]==1) {$data[9]=0;}
			if ($data[6]==2) {$data[7]=null; $data[8]=null; $data[5]=0; $data[9]=0;}
			if (isEmpty($data[15]) || isEmpty($data[16])) {$data[15]=null; $data[16]=null;} else {$data[15]=intval($data[15]); $data[16]=intval($data[16]);}
			
			$dbId=sql_save('edomiProject.editVisuPage',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[4])."'",
				'visuid'		=>	"'".$data[3]."'",
				'includeid'		=>	"'".$data[9]."'",
				'globalinclude'	=>	(($data[14]>0)?1:0),
				'pagetyp'		=>	getNearestNumericValue($data[6],'0,1,2'),
				'xpos'			=>	sql_encodeValue($data[15],true),
				'ypos'			=>	sql_encodeValue($data[16],true),
				'xsize'			=>	sql_encodeValue($data[7],true),
				'ysize'			=>	sql_encodeValue($data[8],true),
				'autoclose'		=>	getNearestNumericValue($data[5],'0,5,10,20,30,60,120,180,300,600,900,1800,3600,7200,10800'),
				'bgcolorid'		=>	sql_encodeValue($data[10],true),
				'bgimg'			=>	sql_encodeValue($data[11],true),
				'xgrid'			=>	(($data[12]>1)?"'".sql_encodeValue($data[12])."'":1),
				'ygrid'			=>	(($data[13]>1)?"'".sql_encodeValue($data[13])."'":1)				
			));
			return $dbId;
		}
	}

	if ($db=='editVisuElement') {

		if ($data[6]==255) {	//Gruppenelement

			//### Achtung: Das Anlegen einer neuen Gruppe wird in app2 erledigt!
			//### Wie ist das beim Import?!

			if ($data[1]>0) {	//Update: nur Name kann geändert werden
				if (!isEmpty($data[20])) {
					$dbId=sql_save('edomiProject.editVisuElement',$data[1],array(
						'name'			=>	"'".sql_encodeValue($data[20])."'"
					));
					return $dbId;
				}
			} else {			//Insert
				if ($data[97]>0 && $data[98]>0 && !isEmpty($data[20])) {
					$dbId=sql_save('edomiProject.editVisuElement',null,array(
						'visuid'		=>	"'".$data[97]."'",
						'pageid'		=>	"'".$data[98]."'",
						'controltyp'	=>	255,
						'xpos'			=>	0,
						'ypos'			=>	0,
						'xsize'			=>	1,
						'ysize'			=>	1,
						'name'			=>	"'".sql_encodeValue($data[20])."'",
						'groupid'		=>	0,
						'tmp'			=>	sql_encodeValue($data[99],true)
					));
					return $dbId;
				}
			}


		} else {	//alle anderen Elemente

			if ($data[97]>0 && $data[98]>0 && is_numeric($data[2]) && is_numeric($data[3]) && $data[8]>=0 && $data[6]>0 && $data[15]>0 && $data[16]>0) {
	
				//### je nach Typ hier noch evaluieren...
				//### z.B. Codeschloss: Code muss genau 4-stellig sein (und Zahlen...), Bild/Website: URL>""...

				$dbId=sql_save('edomiProject.editVisuElement',(($data[1]>0)?$data[1]:null),array(
					'visuid'		=>	"'".$data[97]."'",
					'pageid'		=>	"'".$data[98]."'",
					'controltyp'	=>	getNearestNumericValue($data[6],'1,2,10,11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,30,31,32,33'),
					'xpos'			=>	"'".sql_encodeValue($data[2])."'",
					'ypos'			=>	"'".sql_encodeValue($data[3])."'",
					'xsize'			=>	"'".sql_encodeValue($data[15])."'",
					'ysize'			=>	"'".sql_encodeValue($data[16])."'",
					'gaid'			=>	sql_encodeValue($data[7],true),
					'galive'		=>	getNearestNumericValue($data[96],'0,1'),
					'gaid2'			=>	sql_encodeValue($data[17],true),
					'zindex'		=>	"'".sql_encodeValue($data[8])."'",
					'var1'			=>	sql_encodeValue($data[31],true),
					'var2'			=>	sql_encodeValue($data[32],true),
					'var3'			=>	sql_encodeValue($data[33],true),
					'var4'			=>	sql_encodeValue($data[34],true),
					'var5'			=>	sql_encodeValue($data[35],true),
					'var6'			=>	sql_encodeValue($data[36],true),
					'var7'			=>	sql_encodeValue($data[37],true),
					'var8'			=>	sql_encodeValue($data[38],true),
					'var9'			=>	sql_encodeValue($data[39],true),
					'var10'			=>	sql_encodeValue($data[40],true),
					'gotopageid'	=>	sql_encodeValue($data[13],true),
					'closepopup'	=>	(($data[14]>0)?1:0),
					'text'			=>	sql_encodeValue($data[18],true),
					'initonly'		=>	getNearestNumericValue($data[19],'0,1'),
					'name'			=>	"'".sql_encodeValue($data[20])."'",
					'groupid'		=>	(($data[21]>0)?$data[21]:0),
					'tmp'			=>	sql_encodeValue($data[99],true)
				));
				return $dbId;
			}

		}
	}

	if ($db=='editVisuUser') {
		if (!($data[2]>0)) {$data[2]=23;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && !isEmpty($data[4])) {
			$dbId=sql_save('edomiProject.editVisuUser',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'login'			=>	"'".sql_encodeValue($data[3])."'",
				'pass'			=>	"'".sql_encodeValue($data[4])."'",
				'gaid'			=>	sql_encodeValue($data[11],true),
				'gaid2'			=>	sql_encodeValue($data[13],true),
				'gaid3'			=>	sql_encodeValue($data[14],true),
				'touch'			=>	getNearestNumericValue($data[9],'0,1,2'),
				'touchscroll'	=>	(($data[10]>0)?1:0),
				'autologout'	=>	(($data[12]>0)?1:0)
			));
			return $dbId;
		}
	}
	if ($db=='editVisuUserList') {	

		//Eintrag bereits vorhanden? (Accountzuweisung muss einmalig sein)
		if ($data[1]>0) {
			$tmp=sql_getValue('edomiProject.editVisuUserList','id',"visuid='".$data[2]."' AND targetid='".$data[3]."' AND id<>'".$data[1]."'");
		} else {
			$tmp=sql_getValue('edomiProject.editVisuUserList','id',"visuid='".$data[2]."' AND targetid='".$data[3]."'");
		}

		if ($data[2]>0 && $data[3]>0 && !($tmp>0)) {
			//### Achtung Import: "targetid" ist hier die AccountId des Visuaccounts (um die geht es), "visuid" ist quasi die tatsächliche TargetId...
			//### 	alle anderen Eigenschaften werden von app100 gesetzt (Projektaktivierung)
			$dbId=sql_save('edomiProject.editVisuUserList',(($data[1]>0)?$data[1]:null),array(
				'visuid'		=>	"'".$data[2]."'",				
				'targetid'		=>	"'".$data[3]."'"
			));
			return $dbId;
		}
	}

	if ($db=='editVisuSnd') {
		if (!($data[2]>0)) {$data[2]=29;}	//Defaultordner
		if ($data[2]>0) {
		
			//bei Update: Name darf nicht leer sein
			if ($data[1]>0 && isEmpty($data[3])) {return 0;}
			
			$dbId=sql_save('edomiProject.editVisuSnd',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'"
			));

			if ($data[1]>0) {
/*
				//### testhalber mal weglassen... (RETURN-Wert ist auch noch unklar...)
				if (!(file_exists(MAIN_PATH.'/www/data/project/visu/etc/snd-'.$data[1].'.mp3'))) { //wenn Sounddatei nicht existiert, löschen
					sql_call("DELETE FROM edomiProject.editVisuSnd WHERE (id=".$data[1].")");
					$data[1]=0;
				}
*/
			}

			return $dbId;
		}
	}

	if ($db=='editVisuFont') {
		if (!($data[2]>0)) {$data[2]=150;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3])) {

			if ($data[4]==1) {
				//Custom-Font
				$dbId=sql_save('edomiProject.editVisuFont',(($data[1]>0)?$data[1]:null),array(
					'folderid'		=>	"'".$data[2]."'",
					'name'			=>	"'".sql_encodeValue($data[3])."'",
					'fonttyp'		=>	1,
					'fontname'		=>	"'".date('YmdHis')."'",
					'fontstyle'		=>	(($data[6]>0)?1:0),
					'fontweight'	=>	(($data[7]>0)?1:0)
				));
				return $dbId;

/*
###
Fonts/Bilder/Sounds/LBS(?):
- warum 2-Stufig (Insert->Edit)?
- jetzt würde auch 1-stufig gehen, oder? (die DB-ID für den Dateinamen könnte man ja nach dem Upload vergeben: TMP-Datei beim Speichern umbenennen...)
- cave: Massenupload bei Bildern... -> nee, ist vollkommen unabhängig...


				if ($data[1]>0) {
					if (file_exists(MAIN_PATH.'/www/data/project/visu/etc/font-'.$data[1].'.ttf')) { //Fontdatei vorhanden?
						sql_call("UPDATE edomiProject.editVisuFont SET folderid='".$data[2]."',name='".sql_encodeValue($data[3])."',fonttyp='".$data[4]."',fontname='".date('YmdHis')."',fontstyle='".$data[6]."',fontweight='".$data[7]."' WHERE (id=".$data[1].")");
					} else {
?>
						jsConfirm("Es wurde keine Truetype-Datei hochgeladen.<br><br>Ohne eine gültige Truetype-Datei kann eine individuelle Schriftart nicht gespeichert werden.","","none");
<?
						$err=true;
					}
				} else {
					sql_call("INSERT INTO edomiProject.editVisuFont (folderid,name,fonttyp,fontname,fontstyle,fontweight) VALUES ('".$data[2]."','".sql_encodeValue($data[3])."','".$data[4]."','".date('YmdHis')."','".$data[6]."','".$data[7]."')");
					if (end($data)=='###refresh###' && $id=sql_insertId()) {
						$data[0]=$data[2];
						$data[1]=$id;
						editItem($db);
						$err=true; //damit Edit-Fenster unten nicht geschlossen wird!
					}
				}
*/

			} else {
				//System-Font
				$tmp=explode(',',$data[5],2);
				$data[5]=$tmp[0];
				if (!isEmpty($data[5]) || !($data[1]>0)) {
					$dbId=sql_save('edomiProject.editVisuFont',(($data[1]>0)?$data[1]:null),array(
						'folderid'		=>	"'".$data[2]."'",
						'name'			=>	"'".sql_encodeValue($data[3])."'",
						'fonttyp'		=>	0,
						'fontname'		=>	"'".sql_encodeValue($data[5])."'",
						'fontstyle'		=>	0,
						'fontweight'	=>	0
					));
	
					//ggf. vorhandene Fontdatei löschen
//### könnte auch z.B. in app100 erledigt werden...
					if ($data[1]>0) {
						if (file_exists(MAIN_PATH.'/www/data/project/visu/etc/font-'.$data[1].'.ttf')) {
							deleteFiles(MAIN_PATH.'/www/data/project/visu/etc/font-'.$data[1].'.ttf');
						}
					}
	
					return $dbId;
				}
			}
		}
	}

	if ($db=='editVisuImg') {
		if (!($data[2]>0)) {$data[2]=28;}	//Defaultordner
		if ($data[2]>0) {
		
			if ($data[1]>0) {
				//bei Update: Name darf nicht leer sein
				if (isEmpty($data[3])) {return 0;}
			} else {
				//bei Insert: Defaultwerte (Datei existiert ja noch nicht, da 2-stufiges Erstellen)
				$data[4]=0;
				$data[5]=0;
				$data[6]=null;
			}
			
			$dbId=sql_save('edomiProject.editVisuImg',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'xsize'			=>	"'".sql_encodeValue($data[4])."'",
				'ysize'			=>	"'".sql_encodeValue($data[5])."'",
				'suffix'		=>	sql_encodeValue($data[6],true)
			));

			if ($data[1]>0) {
/*
				//### testhalber mal weglassen... (RETURN-Wert ist auch noch unklar...)
				if (!(file_exists(MAIN_PATH.'/www/data/project/visu/img/img-'.$data[1].'.'.$data[6]))) { //wenn Bilddatei nicht existiert, löschen
					sql_call("DELETE FROM edomiProject.editVisuImg WHERE (id=".$data[1].")");
					$data[1]=0;
				}
*/
			}

			return $dbId;
		}
	}
	if ($db=='editVisuBGcol') {
		if (!($data[2]>0)) {$data[2]=25;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && !isEmpty($data[4])) {
			$dbId=sql_save('edomiProject.editVisuBGcol',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'color'			=>	"'".sql_encodeValue($data[4])."'"
			));
			return $dbId;
		}
	}
	if ($db=='editVisuFGcol') {
		if (!($data[2]>0)) {$data[2]=26;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && !isEmpty($data[4])) {
			$dbId=sql_save('edomiProject.editVisuFGcol',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'color'			=>	"'".sql_encodeValue($data[4])."'"
			));
			return $dbId;
		}
	}
	if ($db=='editVisuAnim') {
		if (!($data[2]>0)) {$data[2]=27;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && !isEmpty($data[4])) {
			$dbId=sql_save('edomiProject.editVisuAnim',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'keyframes'		=>	"'".sql_encodeValue($data[4])."'"
			));
			return $dbId;
		}
	}
	if ($db=='editVisuElementDef') {	
/*
		$var1:
		1=app1003: Update von Design-Eigenschaften (ohne folderid/name)
		2=Import: Insert/Update von allen Eigenschaften
		3=app1000: Insert/Update von folderid/name
*/

		//app1003: Update von Design-Eigenschaften (ohne folderid/name)
		//Import: Insert/Update von allen Eigenschaften
		if ($var1==1 || $var1==2) {

			db_itemSave_parseVisuElementDesignData($data);

			//kein Wertebereich => statisches Design
			if (isEmpty($data[11]) || isEmpty($data[12])) {
				$data[11]='';
				$data[12]='';
				$data[21]='';
				$data[4]=0;	//styletyp=0
			} else {
				$data[4]=1;	//styletyp=1
			}
	
			$tmp=array();
			for ($t=1;$t<=48;$t++) {$tmp['s'.$t]=sql_encodeValue($data[$t+10],true);}		

			if ($var1==1) {
				//app1003: nur Update
				$dbId=sql_save('edomiProject.editVisuElementDef',$data[1],array(
					'styletyp'		=>	(($data[4]>0)?1:0)
				)+$tmp);
			} else {
				//Import: Insert/Update
				$dbId=sql_save('edomiProject.editVisuElementDef',(($data[1]>0)?$data[1]:null),array(
					'folderid'		=>	"'".$data[2]."'",
					'name'			=>	"'".sql_encodeValue($data[3])."'",
					'styletyp'		=>	(($data[4]>0)?1:0)
				)+$tmp);
			}
			return $dbId;
		}

		//app1000: Insert/Update von folderid/name
		if ($var1==3) {
			if ($data[2]>0 && !isEmpty($data[3])) {			
				$dbId=sql_save('edomiProject.editVisuElementDef',(($data[1]>0)?$data[1]:null),array(
					'folderid'		=>	"'".$data[2]."'",
					'name'			=>	"'".sql_encodeValue($data[3])."'"
				));
				return $dbId;
			}
		}
	}
	if ($db=='editVisuElementDesign') {
/*
		$var1: true=dynamisches Design, false=Defaultdesign
*/

		db_itemSave_parseVisuElementDesignData($data);

		//Designvorlage ausgewählt? (zusätzlich zu individueller Eingabe)
		if ($data[3]>0) {	
			$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDef WHERE (id=".$data[3].")");
			if ($tmp=sql_result($ss1)) {
				if ($tmp['styletyp']==0 && $var1) {return 0;}	//Vorlage ist statisch, aber dynamisch ist gefordert
				if ($tmp['styletyp']==1 && !$var1) {return 0;}	//Vorlage ist dynamisch, aber statisch ist gefordert
			} else {
				return 0;										//Vorlage wurde nicht gefunden (kann eigentlich nicht sein)
			}
		}

		//statisch oder dynamisch?
		if ($var1) {	
			//dynamisches Design
			if (!($data[3]>0) && (isEmpty($data[11]) || isEmpty($data[12]))) {return 0;}	//Wertebereich muss angegeben werden, falls kein dyn. Design ausgewählt wurde
			$data[4]=1;	//styletyp=1
		} else {			
			//Defaultdesign
			$data[4]=0;	//styletyp=0
		}

		$tmp=array();
		for ($t=1;$t<=48;$t++) {$tmp['s'.$t]=sql_encodeValue($data[$t+10],true);}		

		$dbId=sql_save('edomiProject.editVisuElementDesign',(($data[1]>0)?$data[1]:null),array(
			'targetid'		=>	"'".$data[2]."'",
			'defid'			=>	"'".$data[3]."'",
			'styletyp'		=>	(($data[4]>0)?1:0)
		)+$tmp); 
		return $dbId;
	}
	if ($db=='editChart') {
		if (!($data[2]>0)) {$data[2]=130;}	//Defaultordner
		if ($data[9]>=1) {$data[9]=intVal($data[9]);} else {$data[9]='';}
		if ($data[2]>0 && !isEmpty($data[3]) && ($data[8]<0 || $data[9]>=1)) {

			if ($data[10]>$data[11] && !isEmpty($data[11])) {
				$tmp=$data[10];
				$data[10]=$data[11];
				$data[11]=$tmp;
			}
			if (!($data[13]>=0) || !is_numeric($data[13])) {$data[13]=0;}

			$dbId=sql_save('edomiProject.editChart',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'titel'			=>	"'".sql_encodeValue($data[4])."'",
				'datefrom'		=>	"'".sql_encodeValue($data[5])."'",
				'dateto'		=>	"'".sql_encodeValue($data[6])."'",
				'mode'			=>	getNearestNumericValue($data[7],'0,1,2,3,4,5,6,7,8,9'),
				'xunit'			=>	getNearestNumericValue($data[8],'-1,0,1,2,3,4,5'),
				'xinterval'		=>	sql_encodeValue($data[9],true),
				'ymin'			=>	sql_encodeValue($data[10],true),
				'ymax'			=>	sql_encodeValue($data[11],true),
				'ynice'			=>	getNearestNumericValue($data[12],'0,1'),
				'yticks'		=>	sql_encodeValue($data[13],true)
			));
			return $dbId;
		}
	}
	if ($db=='editChartList') {	
		if ($data[2]>0 && $data[3]>0 && $data[5]>0 && $data[9]>0 && ($data[19]==0 || $data[20]>0) && $data[24]>=0) {
		
			if ($data[6]>$data[7] && !isEmpty($data[7])) {
				$tmp=$data[6];
				$data[6]=$data[7];
				$data[7]=$tmp;
			}

			$chartTypes1='';
			$chartTypes2='';
			foreach ($global_charttyp as $k => $v) {
				if ($i>0) {$chartTypes1.=$k.',';}
				$chartTypes2.=$k.',';
			}		
		
			$dbId=sql_save('edomiProject.editChartList',(($data[1]>0)?$data[1]:null),array(
				'targetid'		=>	"'".$data[2]."'",				
				'archivkoid'	=>	"'".$data[3]."'",
				'titel'			=>	"'".sql_encodeValue($data[4])."'",
				'charttyp'		=>	getNearestNumericValue($data[5],rtrim($chartTypes1,',')),
				'ymin'			=>	sql_encodeValue($data[6],true),
				'ymax'			=>	sql_encodeValue($data[7],true),
				'ystyle'		=>	getNearestNumericValue($data[8],'0,1,2'),
				's1'			=>	"'".$data[9]."'",
				's2'			=>	getNearestNumericValue($data[10],'100,90,80,70,60,50,40,30,20,10'),
				's3'			=>	getNearestNumericValue($data[11],'1,2,3,4,5,6,7,8,9,10'),
				's4'			=>	getNearestNumericValue($data[12],'0,1,2,3,4,5,6,7,8,9,10'),
				'ygrid1'		=>	getNearestNumericValue($data[13],'0,1,2'),
				'ygrid2'		=>	getNearestNumericValue($data[14],'100,90,80,70,60,50,40,30,20,10'),
				'ygrid3'		=>	(($data[15]>0)?1:0),
				'yshow'			=>	(($data[16]>0)?1:0),
				'ynice'			=>	getNearestNumericValue($data[17],'0,1'),
				'yticks'		=>	(($data[18]>0)?"'".$data[18]."'":0),
				'charttyp2'		=>	getNearestNumericValue($data[19],rtrim($chartTypes2,',')),
				'ss1'			=>	"'".$data[20]."'",
				'ss2'			=>	getNearestNumericValue($data[21],'100,90,80,70,60,50,40,30,20,10'),
				'ss3'			=>	getNearestNumericValue($data[22],'1,2,3,4,5,6,7,8,9,10'),
				'ss4'			=>	getNearestNumericValue($data[23],'0,1,2,3,4,5,6,7,8,9,10'),
				'xinterval'		=>	(($data[24]>0)?"'".$data[24]."'":0),
				'yminmax'		=>	(($data[25]>0)?1:0),
				'extend1'		=>	getNearestNumericValue($data[26],'0,1,2'),
				'extend2'		=>	getNearestNumericValue($data[27],'0,1,2'),
				'yshowvalue'	=>	getNearestNumericValue($data[28],'0,1'),
				'yscale'		=>	(($data[29]>0)?1:0)
			));
			return $dbId;
		}
	}
	if ($db=='editEmail') {
		if (!($data[2]>0)) {$data[2]=120;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && !isEmpty($data[5]) && !isEmpty($data[6])) {
			$dbId=sql_save('edomiProject.editEmail',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'mailaddr'		=>	"'".sql_encodeValue($data[4])."'",
				'subject'		=>	"'".sql_encodeValue($data[5])."'",
				'body'			=>	"'".sql_encodeValue($data[6])."'"
			));
			return $dbId;
		}
	}
	if ($db=='editHttpKo') {
		if (!($data[2]>0)) {$data[2]=140;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && $data[4]>0) {
			$dbId=sql_save('edomiProject.editHttpKo',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'gaid'			=>	sql_encodeValue($data[4],true)
			));
			return $dbId;
		}
	}
	if ($db=='editPhoneBook') {
		if (!($data[2]>0)) {$data[2]=125;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && (!isEmpty($data[4]) || !isEmpty($data[5]))) {
			$dbId=sql_save('edomiProject.editPhoneBook',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'phone1'		=>	"'".sql_encodeValue($data[4])."'",
				'phone2'		=>	"'".sql_encodeValue($data[5])."'"
			));
			return $dbId;
		}
	}
	if ($db=='editPhoneCall') {
		if (!($data[2]>0)) {$data[2]=126;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && ($data[6]>0 || $data[7]>0 || $data[8]>0)) {
			$dbId=sql_save('edomiProject.editPhoneCall',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'phoneid1'		=>	sql_encodeValue($data[4],true),
				'phoneid2'		=>	sql_encodeValue($data[5],true),
				'gaid1'			=>	sql_encodeValue($data[6],true),
				'gaid2'			=>	sql_encodeValue($data[7],true),
				'gaid3'			=>	sql_encodeValue($data[8],true),
				'typ'			=>	(($data[9]>0)?1:0)
			));
			return $dbId;
		}
	}
	if ($db=='editArchivPhone') {
		if (!($data[2]>0)) {$data[2]=127;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && $data[4]>=0 && $data[5]>=0) {
			$dbId=sql_save('edomiProject.editArchivPhone',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'keep'			=>	getNearestNumericValue($data[4],'0,1,2,3,7,14,31,90,180,365,730,1095'),
				'outgaid'		=>	sql_encodeValue($data[5],true)
			));
			return $dbId;
		}
	}
	if ($db=='editIr') {
		if (!($data[2]>0)) {$data[2]=75;}	//Defaultordner
		$data[4]=preg_replace("/[^A-F0-9]+/i",'',$data[4]); //nur HEX zulassen
		if ($data[2]>0 && !isEmpty($data[3])) {
			$dbId=sql_save('edomiProject.editIr',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'data'			=>	sql_encodeValue($data[4],true)
			));
			return $dbId;
		}
	}
	if ($db=='editAws') {
		if (!($data[2]>0)) {$data[2]=110;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && $data[4]>0) {
			$dbId=sql_save('edomiProject.editAws',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'gaid'			=>	sql_encodeValue($data[4],true)
			));
			return $dbId;
		}
	}
	if ($db=='editAwsList') {	
		if ($data[2]>0 && $data[3]>0) {
			$dbId=sql_save('edomiProject.editAwsList',(($data[1]>0)?$data[1]:null),array(
				'targetid'		=>	"'".$data[2]."'",				
				'gaid'			=>	"'".$data[3]."'"
			));
			return $dbId;
		}
	}
	if ($db=='editTimer') {
		if (!($data[2]>0)) {$data[2]=100;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && $data[4]>0 && $data[5]>0) {
			$dbId=sql_save('edomiProject.editTimer',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'gaid'			=>	sql_encodeValue($data[4],true),
				'outgaid'		=>	sql_encodeValue($data[5],true)
			));
			return $dbId;
		}
	}
	if ($db=='editTimerData') {	
		if (isEmpty($data[12]) || $data[12]<1 || $data[12]>31) 		{$data[12]=null;}
		if (isEmpty($data[13]) || $data[13]<1 || $data[13]>12) 		{$data[13]=null;}
		if (isEmpty($data[14]) || $data[14]<0 || $data[14]>9999) 	{$data[14]=null;}
		if (isEmpty($data[15]) || $data[15]<1 || $data[15]>31) 		{$data[15]=null;}
		if (isEmpty($data[16]) || $data[16]<1 || $data[16]>12) 		{$data[16]=null;}
		if (isEmpty($data[17]) || $data[17]<0 || $data[17]>9999) 	{$data[17]=null;}

		//mind. 1 Tag angegeben?
		$dayOk=false;
		for ($t=3;$t<=9;$t++) {
			if ($data[$t]==1) {$dayOk=true; break;}
		}

		if ($data[2]>0 && $dayOk && is_numeric($data[10]) && $data[10]>=0 && $data[10]<=23 && is_numeric($data[11]) && $data[11]>=0 && $data[11]<=59) {
			$dbId=sql_save('edomiProject.editTimerData',(($data[1]>0)?$data[1]:null),array(
				'targetid'		=>	"'".$data[2]."'",				
				'fixed'			=>	1,
				'd0'			=>	(($data[3]>0)?1:0),
				'd1'			=>	(($data[4]>0)?1:0),
				'd2'			=>	(($data[5]>0)?1:0),
				'd3'			=>	(($data[6]>0)?1:0),
				'd4'			=>	(($data[7]>0)?1:0),
				'd5'			=>	(($data[8]>0)?1:0),
				'd6'			=>	(($data[9]>0)?1:0),
				'hour'			=>	intval($data[10]),
				'minute'		=>	intval($data[11]),
				'day1'			=>	sql_encodeValue($data[12],true),
				'month1'		=>	sql_encodeValue($data[13],true),
				'year1'			=>	sql_encodeValue($data[14],true),
				'day2'			=>	sql_encodeValue($data[15],true),
				'month2'		=>	sql_encodeValue($data[16],true),
				'year2'			=>	sql_encodeValue($data[17],true),
				'status'		=>	"'".sql_encodeValue($data[18])."'"
			));
			return $dbId;
		}
	}
	if ($db=='editAgenda') {
		if (!($data[2]>0)) {$data[2]=101;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && $data[4]>0 && $data[5]>0) {
			$dbId=sql_save('edomiProject.editAgenda',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'gaid'			=>	sql_encodeValue($data[4],true),
				'outgaid'		=>	sql_encodeValue($data[5],true)
			));
			return $dbId;
		}
	}
	if ($db=='editAgendaData') {
		if (isEmpty($data[4])) {$data[4]=0;}
		if (isEmpty($data[5])) {$data[5]=0;}

		if (strtotime($data[6])===false) {return 0;}	
		$data[6]=date('Y-m-d',strtotime($data[6]));

		if (!isEmpty($data[7])) {
			if (strtotime($data[7])===false) {return 0;}	
			$data[7]=date('Y-m-d',strtotime($data[7]));
		}

		if ($data[2]>0 && is_numeric($data[4]) && $data[4]>=0 && $data[4]<=23 && is_numeric($data[5]) && $data[5]>=0 && $data[5]<=59) {
			$dbId=sql_save('edomiProject.editAgendaData',(($data[1]>0)?$data[1]:null),array(
				'targetid'		=>	"'".$data[2]."'",				
				'fixed'			=>	1,
				'name'			=>	"'".sql_encodeValue($data[10])."'",
				'status'		=>	"'".sql_encodeValue($data[3])."'",
				'hour'			=>	intval($data[4]),
				'minute'		=>	intval($data[5]),
				'date1'			=>	sql_encodeValue($data[6],true),
				'date2'			=>	sql_encodeValue($data[7],true),
				'step'			=>	((intval($data[8])>0)?intval($data[8]):0),
				'unit'			=>	getNearestNumericValue($data[9],'0,1,2,3')
			));
			return $dbId;
		}
	}
	if ($db=='editSequence') {
		if (!($data[2]>0)) {$data[2]=90;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3])) {
			$dbId=sql_save('edomiProject.editSequence',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'playpointer'	=>	0	// ### überflüssig: 0 ist Defaultvalue in der DB...
			));
			return $dbId;
		}
	}
	if ($db=='editCam') {
		if (!($data[2]>0)) {$data[2]=81;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && !isEmpty($data[4])) {
		
			//Maskierung prüfen/korrigieren (für Import)
			if (!isEmpty($data[6])) {
				$tmp=explode(',',$data[6]);
				if (count($tmp)==6) {
					$tmp[0]=getNearestNumericValue($tmp[0],'0,1,2,3');			//Modus
					$tmp[1]=getNearestNumericValue($tmp[1],'1,2,5,10,15,20');	//Spalten
					$tmp[2]=getNearestNumericValue($tmp[2],'1,2,5,10,15,20');	//Zeilen
					$tmp[3]=strtolower($tmp[3]);								//Farbe (ggf. Zoom per '!')
					$col=ltrim($tmp[3],'!');
					if ($col!='000000' && $col!='343434' && $col!='808080' && $col!='c0c0c0' && $col!='ffffff') {
						if (substr($tmp[3],0,1)=='!') {$tmp[3]='!000000';} else {$tmp[3]='000000';}
					} 
					$tmp[4]=getNearestNumericValue($tmp[4],'30,50,80,100');		//JPG-Qualität
					$anz=intval($tmp[1])*intval($tmp[2]);
					if (strlen($tmp[5])!=$anz) {								//Daten (1/0)
						//alles außer 0 in 1 umwandeln
						$tmp[5]=preg_replace('/[^0]/','1',$tmp[5]);
						//mit Nullen auffüllen (quick and dirty)
						$tmp[5].=str_repeat('0',$anz);
						$tmp[5]=substr($tmp[5],0,$anz);
					}
					$data[6]=implode($tmp,',');			
				} else {
					$data[6]=null;
				}
			}
		
			$dbId=sql_save('edomiProject.editCam',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'url'			=>	"'".sql_encodeValue($data[4])."'",
				'mjpeg'			=>	(($data[5]>0)?1:0),
				'mask'			=>	"'".sql_encodeValue($data[6])."'",
				'datetime'		=>	sql_getNow()
			));
			return $dbId;
		}
	}
	if ($db=='editIp') {
		if (!($data[2]>0)) {$data[2]=70;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && !isEmpty($data[4]) && $data[5]>0 && $data[11]>=1) {
			$dbId=sql_save('edomiProject.editIp',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'url'			=>	"'".sql_encodeValue($data[4])."'",
				'iptyp'			=>	getNearestNumericValue($data[5],'1,2,3,4'),
				'httperrlog'	=>	(($data[7]>0)?1:0),
				'httptimeout'	=>	(($data[11]>=1)?"'".sql_encodeValue($data[11])."'":1),
				'udpraw'		=>	getNearestNumericValue($data[8],'0,1'),
				'outgaid'		=>	sql_encodeValue($data[9],true),
				'outgaid2'		=>	sql_encodeValue($data[10],true),
				'data'			=>	"'".sql_encodeValue($data[6])."'"
			));
			return $dbId;
		}
	}
	if ($db=='editArchivMsg') {
		if (!($data[2]>0)) {$data[2]=60;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && $data[4]>=0 && $data[5]>=0 && $data[6]>=0) {
			$dbId=sql_save('edomiProject.editArchivMsg',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'keep'			=>	getNearestNumericValue($data[4],'0,1,2,3,7,14,31,90,180,365,730,1095'),
				'delay'			=>	(($data[6]>0)?"'".sql_encodeValue($data[6])."'":0),
				'outgaid'		=>	sql_encodeValue($data[5],true)
			));
			return $dbId;
		}
	}
	if ($db=='editArchivKo') {
		if (!($data[2]>0)) {$data[2]=50;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3]) && $data[4]>=0 && $data[5]>=0 && $data[6]>=0) {
			$dbId=sql_save('edomiProject.editArchivKo',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'keep'			=>	getNearestNumericValue($data[4],'0,1,2,3,7,14,31,90,180,365,730,1095'),
				'delay'			=>	(($data[6]>0)?"'".sql_encodeValue($data[6])."'":0),
				'outgaid'		=>	sql_encodeValue($data[5],true)
			));
			return $dbId;
		}
	}
	if ($db=='editArchivCam') {
		if (!($data[2]>0)) {$data[2]=82;}	//Defaultordner
		if ($data[2]>0 && $data[3]>0 && $data[4]>=0 && !isEmpty($data[5]) && $data[6]>=0 && $data[7]>=0 && $data[8]>=0) {
			$dbId=sql_save('edomiProject.editArchivCam',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[5])."'",
				'camid'			=>	sql_encodeValue($data[3],true),
				'keep'			=>	getNearestNumericValue($data[4],'0,1,2,3,7,14,31,90,180,365,730,1095'),
				'delay'			=>	(($data[8]>0)?"'".sql_encodeValue($data[8])."'":0),
				'outgaid'		=>	sql_encodeValue($data[6],true),
				'outgaid2'		=>	sql_encodeValue($data[7],true)
			));
			return $dbId;
		}
	}
	
	if ($db=='editScene') {
		if (!($data[2]>0)) {$data[2]=40;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3])) {
			$dbId=sql_save('edomiProject.editScene',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'"
			));
			return $dbId;
		}
	}
	if ($db=='editSceneList') {	
		if ($data[2]>0 && $data[3]>0 && !isEmpty($data[4]) && $data[5]>=0) {
			$dbId=sql_save('edomiProject.editSceneList',(($data[1]>0)?$data[1]:null),array(
				'targetid'		=>	"'".$data[2]."'",				
				'gaid'			=>	"'".$data[3]."'",
				'gavalue'		=>	sql_encodeValue($data[4],true),
				'learngaid'		=>	(($data[5]>0)?"'".$data[5]."'":0)
			));
			return $dbId;
		}
	}

	if ($db=='editLogicPage') {
		if (!($data[2]>0)) {$data[2]=11;}	//Defaultordner
		if ($data[2]>0 && !isEmpty($data[3])) {
			$dbId=sql_save('edomiProject.editLogicPage',(($data[1]>0)?$data[1]:null),array(
				'folderid'		=>	"'".$data[2]."'",
				'name'			=>	"'".sql_encodeValue($data[3])."'",
				'pagestatus'	=>	(($data[4]>0)?1:0),
				'text'			=>	sql_encodeValue($data[5],true)
			));
			return $dbId;
		}
	}
	
	if ($db=='editKo') {
		if (!($data[2]>0) && $data[4]==2) {$data[2]=31;}	//Defaultordner (internes KO)
		if (!($data[2]>0) && $data[4]==1) {$data[2]=32;}	//Defaultordner (KNX GA)
		//### wird nicht benötigt, da Import keine SysKOs erlaubt
		//### if (!($data[2]>0) && $data[1]>0 && $data[1]<100) {$data[2]=33;}	//Defaultordner (System-KO)
		if ($data[2]>0 && $data[16]!='' && ($data[4]==2 || substr_count($data[3],'/')==2 || ($data[1]==1 && $data[3]=='')) && ($data[5]>0 || $data[4]==2)) {

			$data[3]=trim($data[3]);
			
			if (is_numeric($data[7]) && is_numeric($data[8])) { //min/max ggf. vertauschen
				if ($data[7]>$data[8]) {
					$tmp=$data[7];
					$data[7]=$data[8];
					$data[8]=$tmp;
				}
			}

			if (is_numeric($data[9])) { //vstep darf nicht =< 0 sein
				if (!($data[9]>0)) {
					$data[9]=null;
				}
			}

			if ($data[4]==2) { 			//Internes KO
				$dpts='';
				foreach ($global_dpt as $k => $v) {$dpts.=$k.',';}

				$data[11]=0;
				$data[12]=0;
				$data[13]=0;
				$data[3]=$data[1];

			} else if ($data[4]==1) {	//KNX-GA
				$dpts='';
				foreach ($global_dpt as $k => $v) {if ($k>0) {$dpts.=$k.',';}}

				$data[14]=0;
				
				//GA-Format?
				$tmp=explode('/',$data[3]);
				if (count($tmp)==3) {
					if (!is_numeric($tmp[0]) || $tmp[0]<0 || $tmp[0]>31) 	{return -1;}
					if (!is_numeric($tmp[1]) || $tmp[1]<0 || $tmp[1]>7) 	{return -1;}
					if (!is_numeric($tmp[2]) || $tmp[2]<0 || $tmp[2]>255) 	{return -1;}
				} else {
					return -1;	
				}
				
				//GA schon vorhanden?
				$tmp=sql_getValue('edomiProject.editKo','id',"id<>".$data[1]." AND ga='".sql_encodeValue($data[3])."'");
				if ($tmp>0) {
					return -2;	
				}
			}

			if ($data[2]==33 && $data[1]>0) {
				//System-KOs (Update): Nur defaultvalue/text darf geändert werden
				if ($data[1]==6) {
					//SysKO(6): KO-Monitor
					$dbId=sql_save('edomiProject.editKo',$data[1],array(
						'defaultvalue'	=>	sql_encodeValue($data[6],true),
						'text'			=>	sql_encodeValue($data[17],true)
					));
				} else {
					$dbId=sql_save('edomiProject.editKo',$data[1],array(
						'text'			=>	sql_encodeValue($data[17],true)
					));
				}
			} else if ($data[2]!=33) {	//SysKOs können nicht eingefügt werden (für Import)
				$dbId=sql_save('edomiProject.editKo',(($data[1]>0)?$data[1]:null),array(
					'folderid'		=>	"'".$data[2]."'",
					'name'			=>	"'".sql_encodeValue($data[16])."'",
					'ga'			=>	sql_encodeValue($data[3],true),
					'gatyp'			=>	"'".$data[4]."'",
					'valuetyp'		=>	getNearestNumericValue($data[5],rtrim($dpts,',')),
					'defaultvalue'	=>	sql_encodeValue($data[6],true),
					'initscan'		=>	(($data[11]>0)?1:0),
					'initsend'		=>	(($data[12]>0)?1:0),
					'remanent'		=>	(($data[14]>0)?1:0),
					'requestable'	=>	getNearestNumericValue($data[13],'0,1,2,3,4,5,6'),
					'vmin'			=>	sql_encodeValue($data[7],true),
					'vmax'			=>	sql_encodeValue($data[8],true),
					'vstep'			=>	sql_encodeValue($data[9],true),
					'vlist'			=>	((isEmpty($data[10]))?'null':getNearestNumericValue($data[10],'0,1,2,3,4,5')),
					'vcsv'			=>	sql_encodeValue($data[18],true),
					'text'			=>	sql_encodeValue($data[17],true)
				));
				//ga=id setzen
				if ($dbId!==false) {sql_call("UPDATE edomiProject.editKo SET ga=id WHERE id=".$dbId." AND gatyp=2");}
			}
			return $dbId;
		}
	}
	
	return 0;
}

function db_itemSave_parseVisuElementDesignData(&$data) {
	//editVisuElementDesign und editVisuElementDef: s1..s47 prüfen und korrigieren

	//ggf. Wertebereich tauschen
	if ($data[11]>$data[12]) {
		$n=$data[11];
		$data[11]=$data[12];
		$data[12]=$n;
	}

	//### Alles-oder-Nichts-Angaben
	//### ggf. noch weitere Eingaben prüfen! cave: {#...}, d.h. einfach is_numeric(...) funktioniert nicht

	//"leere" Auswahlfelder auf '' setzen (können u.U. "0" enthalten nach einem "Zurücksetzen")
	if (!($data[19]>0)) {$data[19]='';}
	if (!($data[20]>0)) {$data[20]='';}
	if (!($data[23]>0)) {$data[23]='';}
	if (!($data[25]>0)) {$data[25]='';}
	if (!($data[32]>0)) {$data[32]='';}
	if (!($data[37]>0)) {$data[37]='';}
	if (!($data[38]>0)) {$data[38]='';}
	if (!($data[39]>0)) {$data[39]='';}
	if (!($data[40]>0)) {$data[40]='';}
	if (!($data[47]>0)) {$data[47]='';}
	if (!($data[48]>0)) {$data[48]='';}
	if (!($data[49]>0)) {$data[49]='';}
	if (!($data[52]>0)) {$data[52]='';}
	if (!($data[53]>0)) {$data[53]='';}
	if (!($data[54]>0)) {$data[54]='';}
	if (!($data[55]>0)) {$data[55]='';}
	if (!($data[56]>0)) {$data[56]='';}
	if (!($data[57]>0)) {$data[57]='';}
}

//---------------------------------------------------------------------------------------------------------------------------------------------
//Elemente: Verweise prüfen
//---------------------------------------------------------------------------------------------------------------------------------------------

function checkItemLinks($db,$id) {
	//Verweise auf ein Element prüfen
	//return: Info-String mit den Verweisen (getrennt mit <br>), oder '' (keine Verweise vorhanden)

	$info='';

	if ($db=='editLogicPage') {
		//nichts...

	} else if ($db=='editLogicElementDef') {
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicElement WHERE (functionid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.$n['pageid'].', LBS-Instanz '.$n['id'].': LBS '.$n['functionid'].'<br>';
		}
		
	} else if ($db=='editVisu') {
		//Visualarm für alle Seiten dieser Visu prüfen
		$ss2=sql_call("SELECT id FROM edomiProject.editVisuPage WHERE (visuid=".$id.")");
		while ($page=sql_result($ss2)) {
			$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE (outmode=21 AND outid=".$page['id'].")"); //Visualarm
			while ($n=sql_result($ss1)) {
				//die zu löschende VisuId muss natürlich ausgenommen werden:
				$tmp=sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']);
				if ($tmp!=$id) {	
					$info.='&middot; Visu '.$tmp.', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl (Visuseite aufrufen)<br>';
				}
			}
			$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE (outmode=21 AND outid=".$page['id'].")"); //Visualarm
			while ($n=sql_result($ss1)) {
				$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Befehl (Visuseite aufrufen)<br>';
			}
			$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE (outmode=21 AND outid=".$page['id'].")"); //Visualarm
			while ($n=sql_result($ss1)) {
				$info.='&middot; Sequenz '.$n['targetid'].': Befehl (Visuseite aufrufen)<br>';
			}
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE ((outmode=23 OR outmode=24 OR outmode=26 OR outmode=28) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE ((outmode=23 OR outmode=24 OR outmode=26 OR outmode=28) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Ausgangsbox<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE ((outmode=23 OR outmode=24 OR outmode=26 OR outmode=28) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl<br>';
		}
		
	} else if ($db=='editVisuPage') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisu WHERE (defaultpageid=".$id." OR sspageid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['id'].': Startseite/Bildschirmschoner<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuPage WHERE (includeid=".$id.")"); //Inklude
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].', Seite '.$n['id'].': Inkludeseite<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElement WHERE (gotopageid=".$id.")"); //Visu-Seite aufrufen
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].', Seite '.$n['pageid'].', Element '.$n['id'].': Seitenverweis<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE (outmode=21 AND outid=".$id.")"); //Visualarm
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl (Visuseite aufrufen)<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE (outmode=21 AND outid=".$id.")"); //Visualarm
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Befehl (Visuseite aufrufen)<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE (outmode=21 AND outid=".$id.")"); //Visualarm
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl (Visuseite aufrufen)<br>';
		}
		
	} else if ($db=='editVisuUser') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuUserList WHERE (targetid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].': Visuaccount<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE ((outmode=21 OR outmode=23 OR outmode=28) AND outvalue=".$id.") OR ((outmode=25 OR outmode=27) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE ((outmode=21 OR outmode=23 OR outmode=28) AND outvalue=".$id.") OR ((outmode=25 OR outmode=27) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Ausgangsbox<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE ((outmode=21 OR outmode=23 OR outmode=28) AND outvalue=".$id.") OR ((outmode=25 OR outmode=27) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl<br>';
		}
		
	} else if ($db=='editVisuElementDef') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDesign WHERE (defid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Designvorlage<br>';
		}
		
	} else if ($db=='editVisuBGcol') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuPage WHERE (bgcolorid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].', Seite '.$n['id'].', Hintergrundfarbe<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDesign WHERE (s9=".$id." OR s44=".$id." OR s45=".$id.") GROUP BY targetid");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].'<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDef WHERE (s9=".$id." OR s44=".$id." OR s45=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Designvorlage '.$n['id'].'<br>';
		}
		
	} else if ($db=='editVisuFGcol') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDesign WHERE (s15=".$id." OR s22=".$id." OR s27=".$id." OR s28=".$id." OR s29=".$id." OR s30=".$id." OR s37=".$id." OR s42=".$id." OR s43=".$id.") GROUP BY targetid");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].'<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDef WHERE (s15=".$id." OR s22=".$id." OR s27=".$id." OR s28=".$id." OR s29=".$id." OR s30=".$id." OR s37=".$id." OR s42=".$id." OR s43=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Designvorlage '.$n['id'].'<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editChartList WHERE (s1=".$id." OR ss1=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Diagramm '.$n['targetid'].', Datenquelle '.$n['id'].'<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisu WHERE (indicolor=".$id." OR indicolor2=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['id'].': Indikatorfarbe/Eingabefarbe<br>';
		}
		
	} else if ($db=='editVisuAnim') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDesign WHERE (s39=".$id.") GROUP BY targetid");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].'<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDef WHERE (s39=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Designvorlage '.$n['id'].'<br>';
		}
		
	} else if ($db=='editVisuImg') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuPage WHERE (bgimg=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].', Seite '.$n['id'].', Hintergrundbild<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDesign WHERE (s10=".$id." OR s46=".$id." OR s47=".$id.") GROUP BY targetid");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].'<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDef WHERE (s10=".$id." OR s46=".$id." OR s47=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Designvorlage '.$n['id'].'<br>';
		}
		
	} else if ($db=='editVisuSnd') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE ((outmode=24 OR outmode=25) AND outvalue=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE ((outmode=24 OR outmode=25) AND outvalue=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Ausgangsbox<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE ((outmode=24 OR outmode=25) AND outvalue=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl<br>';
		}

	} else if ($db=='editVisuFont') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDesign WHERE (s13=".$id.") GROUP BY targetid");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].'<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDef WHERE (s13=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Designvorlage '.$n['id'].'<br>';
		}
		
	} else if ($db=='editKo') {
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicLink WHERE (linktyp=0 AND linkid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['elementid']).', LBS '.$n['elementid'].': Eingang '.$n['eingang'].'<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE (outmode>0 AND outmode<10 AND ((outid=".$id.") OR ((outmode=3 OR outmode=6) AND outvalue=".$id.")))");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Ausgangsbox<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE (outmode>0 AND outmode<10 AND ((outid=".$id.") OR ((outmode=3 OR outmode=6) AND outvalue=".$id.")))");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElement WHERE (gaid=".$id." OR gaid2=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].', Seite '.$n['pageid'].', Element '.$n['id'].': KO(s)<br>';
		}
		$ss1=sql_call("SELECT id FROM edomiProject.editVisuUser WHERE (gaid=".$id." OR gaid2=".$id." OR gaid3=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visuaccount '.$n['id'].': Status-KO<br>';
		}
		$ss1=sql_call("SELECT id FROM edomiProject.editAws WHERE (gaid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Anwesenheitssimulation '.$n['id'].': Steuerungs-KO<br>';
		}
		$ss1=sql_call("SELECT targetid FROM edomiProject.editAwsList WHERE (gaid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Anwesenheitssimulation '.$n['targetid'].': KO (Aufzeichnung)<br>';
		}
		$ss1=sql_call("SELECT id FROM edomiProject.editHttpKo WHERE (gaid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Fernzugriff '.$n['id'].': KO<br>';
		}
		$ss1=sql_call("SELECT id FROM edomiProject.editPhoneCall WHERE (gaid1=".$id." OR gaid2=".$id." OR gaid3=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Anruftrigger '.$n['id'].': Status-KO<br>';
		}
		$ss1=sql_call("SELECT targetid FROM edomiProject.editSequenceList WHERE (outmode>0 AND outmode<10 AND ((outid=".$id.") OR ((outmode=3 OR outmode=6) AND outvalue=".$id.")))");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT targetid FROM edomiProject.editSceneList WHERE (gaid=".$id." OR learngaid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Szene '.$n['targetid'].': KO/Lern-KO<br>';
		}
		$ss1=sql_call("SELECT id FROM edomiProject.editTimer WHERE (gaid=".$id." OR outgaid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Zeitschaltuhr '.$n['id'].': Steuerungs-/Status-KO<br>';
		}
		$ss1=sql_call("SELECT id FROM edomiProject.editAgenda WHERE (gaid=".$id." OR outgaid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Terminschaltuhr '.$n['id'].': Steuerungs-/Status-KO<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editArchivCam WHERE (outgaid=".$id." OR outgaid2=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Kameraarchiv '.$n['id'].': Status-/Metadaten-KO<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editArchivKo WHERE (outgaid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Datenarchiv '.$n['id'].': KO<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editArchivMsg WHERE (outgaid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Meldungsarchiv '.$n['id'].': KO<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editArchivPhone WHERE (outgaid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Anrufarchiv '.$n['id'].': KO<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editIp WHERE (outgaid=".$id." OR outgaid2=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; HTTP/UDP/SHELL '.$n['id'].': Antwort-/Fehler-KO<br>';
		}
		
	} else if ($db=='editScene') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE (outmode=10 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE (outmode=10 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Ausgangsbox<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE (outmode=10 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl<br>';
		}
		
	} else if ($db=='editArchivKo') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElement WHERE (var1=".$id." AND controltyp=26)");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].', Seite '.$n['pageid'].', Element '.$n['id'].': Datenarchiv<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE ((outmode=13 || outmode=40 || outmode=50) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE ((outmode=13 || outmode=40 || outmode=50) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Ausgangsbox<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE ((outmode=13 || outmode=40 || outmode=50) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editChartList WHERE (archivkoid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Diagramm '.$n['targetid'].', Datenquelle '.$n['id'].'<br>';
		}
		
	} else if ($db=='editArchivMsg') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElement WHERE (var1=".$id." AND controltyp=25)");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].', Seite '.$n['pageid'].', Element '.$n['id'].': Meldungsarchiv<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE ((outmode=14 || outmode=41 || outmode=51) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE ((outmode=14 || outmode=41 || outmode=51) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Ausgangsbox<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE ((outmode=14 || outmode=41 || outmode=51) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl<br>';
		}
		
	} else if ($db=='editIp') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE (outmode=15 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE (outmode=15 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Ausgangsbox<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE (outmode=15 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl<br>';
		}
		
	} else if ($db=='editIr') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE (outmode=16 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE (outmode=16 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Ausgangsbox<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE (outmode=16 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl<br>';
		}
		
	} else if ($db=='editCam') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElement WHERE (var1=".$id." AND controltyp=20)");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].', Seite '.$n['pageid'].', Element '.$n['id'].': Kamerabild<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editArchivCam WHERE (camid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Kameraarchiv '.$n['id'].': Kamera<br>';
		}
		
	} else if ($db=='editArchivCam') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElement WHERE (var3=".$id." AND controltyp=20)");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].', Seite '.$n['pageid'].', Element '.$n['id'].': Kameraarchiv<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE ((outmode=12 || outmode=52) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE ((outmode=12 || outmode=52) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Ausgangsbox<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE ((outmode=12 || outmode=52) AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl<br>';
		}
		
	} else if ($db=='editSequence') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE (outmode=11 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE (outmode=11 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Ausgangsbox<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE (outmode=11 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl<br>';
		}
		
	} else if ($db=='editTimer') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElement WHERE (var1=".$id." AND controltyp=22)");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].', Seite '.$n['pageid'].', Element '.$n['id'].': Zeitschaltuhr<br>';
		}
		
	} else if ($db=='editAgenda') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElement WHERE (var1=".$id." AND controltyp=32)");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].', Seite '.$n['pageid'].', Element '.$n['id'].': Terminschaltuhr<br>';
		}

	} else if ($db=='editAws') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElement WHERE (var1=".$id." AND controltyp=23)");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].', Seite '.$n['pageid'].', Element '.$n['id'].': Anwesenheitssimulation<br>';
		}
		
	} else if ($db=='editEmail') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE (outmode=20 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE (outmode=20 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Ausgangsbox<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE (outmode=20 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl<br>';
		}
		
	} else if ($db=='editPhoneBook') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE (outmode=22 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE (outmode=22 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Ausgangsbox<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE (outmode=22 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl<br>';
		}

	} else if ($db=='editPhoneCall') {
		//nichts...
		
	} else if ($db=='editArchivPhone') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElement WHERE (var1=".$id." AND controltyp=28)");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].', Seite '.$n['pageid'].', Element '.$n['id'].': Anrufarchiv<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE (outmode=53 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.sql_getValue('edomiProject.editVisuElement','visuid','id='.$n['targetid']).', Seite '.sql_getValue('edomiProject.editVisuElement','pageid','id='.$n['targetid']).', Element '.$n['targetid'].': Befehl<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE (outmode=53 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Logik, Seite '.sql_getValue('edomiProject.editLogicElement','pageid','id='.$n['targetid']).', LBS '.$n['targetid'].': Ausgangsbox<br>';
		}
		$ss1=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE (outmode=53 AND outid=".$id.")");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Sequenz '.$n['targetid'].': Befehl<br>';
		}
		
	} else if ($db=='editChart') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElement WHERE (var1=".$id." AND controltyp=21)");
		while ($n=sql_result($ss1)) {
			$info.='&middot; Visu '.$n['visuid'].', Seite '.$n['pageid'].', Element '.$n['id'].': Diagramm<br>';
		}
		
	} else if ($db=='editHttpKo') {
		//nichts...
	}

	return $info;
}


//---------------------------------------------------------------------------------------------------------------------------------------------
//Ordner: Löschen, Verschieben, Duplizieren
//---------------------------------------------------------------------------------------------------------------------------------------------

function db_folderDelete($id,$firstcall=true) {
	//löscht den (User)Ordner $id mit allen Inhalten (Items und Subfolder)
	//return: true=Ok, false=Fehler (z.B. keine Rechte, Items konnten nicht vollständig gelöscht werden, etc.)
	
	$folder=sql_getValues('edomiProject.editRoot','*','id>=1000 && id='.$id);
	if ($folder!==false) {

		if ($firstcall) {
			//Rechte checken
			$allow=dbRoot_getAllow($folder['id']);
			if ($allow===false || !($allow&64)) {return false;}
			
			//Markierungen zurücksetzen
			sql_call("UPDATE edomiProject.editRoot SET tmp=0");
		}
		
		//Items löschen
		$ss1=sql_call("SELECT id FROM edomiProject.".$folder['namedb']." WHERE (folderid=".$folder['id'].")");
		while ($item=sql_result($ss1)) {
			db_itemDelete($folder['namedb'],$item['id']);
		}
		sql_close($ss1);

		//Sind alle Items gelöscht?
		if (sql_getCount('edomiProject.'.$folder['namedb'],'folderid='.$folder['id'])==0) {
			$ok=true;
			
			//Ordner markieren (zum späteren Löschen)
			$r=sql_call("UPDATE edomiProject.editRoot SET tmp=1 WHERE id=".$folder['id']);
			if (!$r) {$ok=false;}

			//Subfolder:
			$ss1=sql_call("SELECT id FROM edomiProject.editRoot WHERE parentid=".$folder['id']);
			while ($n=sql_result($ss1)) {
				$r=db_folderDelete($n['id'],false);
				if (!$r) {$ok=false;}
			}
			sql_close($ss1);

			if ($firstcall && $ok) {			
				//alle markierten Ordner löschen (zur Sicherheit zusätzlich Pfad prüfen)
				sql_call("DELETE FROM edomiProject.editRoot WHERE tmp=1 AND (id=".$folder['id']." OR path LIKE '%/".$folder['id']."/%')");
				if (sql_getCount('edomiProject.editRoot','tmp=1')>0) {$ok=false;}
			}

			return $ok;					
		} else {
			return false;
		}
	}	
	return false;
}

function db_folderMove($id,$targetFolderId,$firstcall=true) {
	//return: ID des verschobenen Ordners (entspricht $id), oder false=Fehler
	
	if (!($targetFolderId>0)) {return false;}
		
	$srcFolder=sql_getValues('edomiProject.editRoot','*','id='.$id);
	if ($srcFolder!==false) {

		//Rechte checken: Zielordner muss Copy/Paste erlauben
		if ($firstcall) {
			$allow=dbRoot_getAllow($targetFolderId);
			if ($allow===false || !($allow&16)) {return false;}
		}

		$dbId=db_itemSave('editRoot',array(
			1	=>	$srcFolder['id'],
			3	=>	$targetFolderId
		));

		if ($dbId>0) {

			//Subfolder:
			$ss1=sql_call("SELECT id FROM edomiProject.editRoot WHERE parentid=".$srcFolder['id']." ORDER BY id ASC");
			while ($n=sql_result($ss1)) {
				$tmp=db_folderMove($n['id'],$dbId,false);
			}
			sql_close($ss1);

			return $dbId;		
		}
	}	
	return false;
}

function db_folderDuplicate($id,$targetFolderId=0,$nameSuffix='',$firstcall=true) {
	//return: ID des Duplikats, oder false=Fehler
		
	$srcFolder=sql_getValues('edomiProject.editRoot','*','id='.$id);
	if ($srcFolder!==false) {

		//Rechte checken: Ordner bzw. Zielordner muss Copy/Paste und Duplizieren erlauben
		if ($firstcall) {
			$allow=dbRoot_getAllow((($targetFolderId>0)?$targetFolderId:$srcFolder['id']));
			if ($allow===false || !($allow&16) || !($allow&32)) {return false;}
		}

		$dbId=db_itemSave('editRoot',array(
			1	=>	-1,
			2	=>	$srcFolder['name'].$nameSuffix,
			3	=>	(($targetFolderId>0)?$targetFolderId:$srcFolder['parentid']),
			4	=>	$srcFolder['linkid']
		));

		if ($dbId>0) {

			//Items duplizieren:
			$ss1=sql_call("SELECT id FROM edomiProject.".$srcFolder['namedb']." WHERE folderid=".$srcFolder['id']." ORDER BY id ASC");
			while ($n=sql_result($ss1)) {
				$tmp=db_itemDuplicate($srcFolder['namedb'],$n['id'],$dbId,'');
			}
			sql_close($ss1);

			//Subfolder:
			$ss1=sql_call("SELECT id FROM edomiProject.editRoot WHERE parentid=".$srcFolder['id']." ORDER BY id ASC");
			while ($n=sql_result($ss1)) {
				$tmp=db_folderDuplicate($n['id'],$dbId,'',false);
			}
			sql_close($ss1);
		
			return $dbId;
		}
	}
	return false;
}


//---------------------------------------------------------------------------------------------------------------------------------------------
//Elemente: Löschen
//---------------------------------------------------------------------------------------------------------------------------------------------

function db_itemDelete($db,$id) {
	//Element einschließlich aller Verweise auf das Element löschen
	//(Verweise werden entweder gelöscht oder zurückgesetzt, je nach Element-Typ)

	if ($db=='editRoot') {	
		$r=db_folderDelete($id);
		return $r;
	}
	
	if ($db=='editLogicPage') {
		$ss1=sql_call("SELECT b.elementid FROM edomiProject.editLogicElement AS a,edomiProject.editLogicElementVar AS b WHERE (a.pageid=".$id." AND b.elementid=a.id) GROUP BY b.elementid");
		while ($n=sql_result($ss1)) {
			sql_call("DELETE FROM edomiProject.editLogicElementVar WHERE (elementid=".$n['elementid'].")");
		}
		$ss1=sql_call("SELECT b.elementid FROM edomiProject.editLogicElement AS a,edomiProject.editLogicLink AS b WHERE (a.pageid=".$id." AND b.elementid=a.id) GROUP BY b.elementid");
		while ($n=sql_result($ss1)) {
			sql_call("DELETE FROM edomiProject.editLogicLink WHERE (elementid=".$n['elementid'].")");
		}
		$ss1=sql_call("SELECT b.targetid FROM edomiProject.editLogicElement AS a,edomiProject.editLogicCmdList AS b WHERE (a.pageid=".$id." AND b.targetid=a.id) GROUP BY b.targetid");
		while ($n=sql_result($ss1)) {
			sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE (targetid=".$n['targetid'].")");
		}
		sql_call("DELETE FROM edomiProject.editLogicElement WHERE (pageid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicPage WHERE (id=".$id.")");
		
		//Verweise gibt es nicht

	} else if ($db=='editLogicElementDef') {
		sql_call("DELETE FROM edomiProject.editLogicElementDef WHERE id=".$id);
		sql_call("DELETE FROM edomiProject.editLogicElementDefIn WHERE targetid=".$id);
		sql_call("DELETE FROM edomiProject.editLogicElementDefOut WHERE targetid=".$id);
		sql_call("DELETE FROM edomiProject.editLogicElementDefVar WHERE targetid=".$id);
		deleteFiles(MAIN_PATH.'/www/admin/help/lbs_'.$id.'.htm');
		deleteFiles(MAIN_PATH.'/www/admin/lbs/'.$id.'_lbs.php');

		//Verweise (LBS-Instanzen):		
		$ss1=sql_call("SELECT id FROM edomiProject.editLogicElement WHERE functionid=".$id);
		while ($n=sql_result($ss1)) {
			db_itemDelete('editLogicElement',$n['id']);
		}
		sql_close($ss1);		

	} else if ($db=='editVisu') {
		//Verweise (hier zuerst, da editVisuPage für Verweise benötigt wird)
		$ss2=sql_call("SELECT id FROM edomiProject.editVisuPage WHERE (visuid=".$id.")");
		while ($page=sql_result($ss2)) {
			sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE (outmode=21 AND outid=".$page['id'].")");
			sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE (outmode=21 AND outid=".$page['id'].")");
			sql_call("DELETE FROM edomiProject.editSequenceList WHERE (outmode=21 AND outid=".$page['id'].")");
		}
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE ((outmode=23 OR outmode=24 OR outmode=26 OR outmode=28) AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE ((outmode=23 OR outmode=24 OR outmode=26 OR outmode=28) AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE ((outmode=23 OR outmode=24 OR outmode=26 OR outmode=28) AND outid=".$id.")");

		//alle Elemente dieser Visu löschen
		$ss1=sql_call("SELECT id FROM edomiProject.editVisuPage WHERE (visuid=".$id.")");
		while ($page=sql_result($ss1)) {
			$ss2=sql_call("SELECT b.targetid FROM edomiProject.editVisuElement AS a,edomiProject.editVisuCmdList AS b WHERE (a.pageid=".$page['id']." AND b.targetid=a.id) GROUP BY b.targetid");
			while ($n=sql_result($ss2)) {
				sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE (targetid=".$n['targetid'].")");
			}
			$ss2=sql_call("SELECT b.targetid FROM edomiProject.editVisuElement AS a,edomiProject.editVisuElementDesign AS b WHERE (a.pageid=".$page['id']." AND b.targetid=a.id) GROUP BY b.targetid");
			while ($n=sql_result($ss2)) {
				sql_call("DELETE FROM edomiProject.editVisuElementDesign WHERE (targetid=".$n['targetid'].")");
			}
		}
		sql_call("DELETE FROM edomiProject.editRoot WHERE (link='22' AND linkid=".$id.")");
		sql_call("DELETE FROM edomiProject.editVisuUserList WHERE (visuid=".$id.")");
		sql_call("DELETE FROM edomiProject.editVisuElement WHERE (visuid=".$id.")");
		sql_call("DELETE FROM edomiProject.editVisuPage WHERE (visuid=".$id.")");
		sql_call("DELETE FROM edomiProject.editVisu WHERE (id=".$id.")");


	} else if ($db=='editVisuPage') {
		$ss1=sql_call("SELECT b.targetid FROM edomiProject.editVisuElement AS a,edomiProject.editVisuCmdList AS b WHERE (a.pageid=".$id." AND b.targetid=a.id) GROUP BY b.targetid");
		while ($n=sql_result($ss1)) {
			sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE (targetid=".$n['targetid'].")");
		}
		$ss1=sql_call("SELECT b.targetid FROM edomiProject.editVisuElement AS a,edomiProject.editVisuElementDesign AS b WHERE (a.pageid=".$id." AND b.targetid=a.id) GROUP BY b.targetid");
		while ($n=sql_result($ss1)) {
			sql_call("DELETE FROM edomiProject.editVisuElementDesign WHERE (targetid=".$n['targetid'].")");
		}
		sql_call("DELETE FROM edomiProject.editVisuElement WHERE (pageid=".$id.")"); //visuId ist egal, weil die pageId bereits eindeutig ist...
		sql_call("DELETE FROM edomiProject.editVisuPage WHERE (id=".$id.")");
		sql_call("UPDATE edomiProject.editVisuPage SET includeid=0 WHERE (includeid=".$id.")"); //ggf. Include-Seite auf 0 setzen...
		sql_call("UPDATE edomiProject.editVisu SET sspageid=0 WHERE (sspageid=".$id.")"); //ggf. BS-Seite auf 0 setzen...

		//Verweise
		sql_call("UPDATE edomiProject.editVisu SET defaultpageid=NULL WHERE (defaultpageid=".$id.")");
		sql_call("UPDATE edomiProject.editVisu SET sspageid=NULL WHERE (sspageid=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElement SET gotopageid=NULL WHERE (gotopageid=".$id.")");
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE (outmode=21 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE (outmode=21 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE (outmode=21 AND outid=".$id.")");

	} else if ($db=='editVisuUser') {
		sql_call("DELETE FROM edomiProject.editVisuUserList WHERE (targetid=".$id.")");
		sql_call("DELETE FROM edomiProject.editVisuUser WHERE (id=".$id.")");

		//Verweise
		sql_call("DELETE FROM edomiProject.editVisuUserList WHERE (targetid=".$id.")");
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE ((outmode=21 OR outmode=23 OR outmode=28) AND outvalue=".$id.") OR ((outmode=25 OR outmode=27) AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE ((outmode=21 OR outmode=23 OR outmode=28) AND outvalue=".$id.") OR ((outmode=25 OR outmode=27) AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE ((outmode=21 OR outmode=23 OR outmode=28) AND outvalue=".$id.") OR ((outmode=25 OR outmode=27) AND outid=".$id.")");

	} else if ($db=='editVisuElementDef') {
		sql_call("DELETE FROM edomiProject.editVisuElementDef WHERE (id=".$id.")");

		//Verweise
		sql_call("DELETE FROM edomiProject.editVisuElementDesign WHERE (defid=".$id.")");

	} else if ($db=='editVisuBGcol') {
		sql_call("DELETE FROM edomiProject.editVisuBGcol WHERE (id=".$id.")");

		//Verweise
		sql_call("UPDATE edomiProject.editVisuPage SET bgcolorid=NULL WHERE (bgcolorid=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s9=NULL WHERE (s9=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s44=NULL WHERE (s44=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s45=NULL WHERE (s45=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s9=NULL WHERE (s9=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s44=NULL WHERE (s44=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s45=NULL WHERE (s45=".$id.")");

	} else if ($db=='editVisuFGcol') {
		sql_call("DELETE FROM edomiProject.editVisuFGcol WHERE (id=".$id.")");

		//Verweise
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s15=NULL WHERE (s15=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s22=NULL WHERE (s22=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s27=NULL WHERE (s27=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s28=NULL WHERE (s28=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s29=NULL WHERE (s29=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s30=NULL WHERE (s30=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s37=NULL WHERE (s37=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s42=NULL WHERE (s42=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s43=NULL WHERE (s43=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s15=NULL WHERE (s15=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s22=NULL WHERE (s22=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s27=NULL WHERE (s27=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s28=NULL WHERE (s28=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s29=NULL WHERE (s29=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s30=NULL WHERE (s30=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s37=NULL WHERE (s37=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s42=NULL WHERE (s42=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s43=NULL WHERE (s43=".$id.")");
		sql_call("UPDATE edomiProject.editChartList SET s1=NULL WHERE (s1=".$id.")");
		sql_call("UPDATE edomiProject.editChartList SET ss1=NULL WHERE (ss1=".$id.")");
		sql_call("UPDATE edomiProject.editVisu SET indicolor=NULL WHERE (indicolor=".$id.")");
		sql_call("UPDATE edomiProject.editVisu SET indicolor2=NULL WHERE (indicolor2=".$id.")");

	} else if ($db=='editVisuAnim') {
		sql_call("DELETE FROM edomiProject.editVisuAnim WHERE (id=".$id.")");
		
		//Verweise
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s39=NULL,s40=NULL,s41=NULL WHERE (s39=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s39=NULL,s40=NULL,s41=NULL WHERE (s39=".$id.")");

	} else if ($db=='editVisuImg') {
		deleteFiles(MAIN_PATH.'/www/data/project/visu/img/img-'.$id.'.*');
		sql_call("DELETE FROM edomiProject.editVisuImg WHERE (id=".$id.")");
		
		//Verweise
		sql_call("UPDATE edomiProject.editVisuPage SET bgimg=0 WHERE (bgimg=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s10=NULL WHERE (s10=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s46=NULL WHERE (s46=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s47=NULL WHERE (s47=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s10=NULL WHERE (s10=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s46=NULL WHERE (s46=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s47=NULL WHERE (s47=".$id.")");

	} else if ($db=='editVisuSnd') {
		deleteFiles(MAIN_PATH.'/www/data/project/visu/etc/snd-'.$id.'.mp3');
		sql_call("DELETE FROM edomiProject.editVisuSnd WHERE (id=".$id.")");

		//Verweise
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE ((outmode=24 OR outmode=25) AND outvalue=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE ((outmode=24 OR outmode=25) AND outvalue=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE ((outmode=24 OR outmode=25) AND outvalue=".$id.")");

	} else if ($db=='editVisuFont') {
		sql_call("DELETE FROM edomiProject.editVisuFont WHERE (id=".$id.")");

		//Verweise
		sql_call("UPDATE edomiProject.editVisuElementDesign SET s13=NULL WHERE (s13=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElementDef SET s13=NULL WHERE (s13=".$id.")");

	} else if ($db=='editKo') {
		sql_call("DELETE FROM edomiProject.editKo WHERE (id=".$id.")");

		//Verweise
		sql_call("UPDATE edomiProject.editLogicLink SET linktyp=2,linkid=NULL WHERE (linktyp=0 AND linkid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE (outmode>0 AND outmode<10 AND ((outid=".$id.") OR ((outmode=3 OR outmode=6) AND outvalue=".$id.")))");
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE (outmode>0 AND outmode<10 AND ((outid=".$id.") OR ((outmode=3 OR outmode=6) AND outvalue=".$id.")))");
		sql_call("UPDATE edomiProject.editVisuElement SET gaid=NULL WHERE (gaid=".$id.")");
		sql_call("UPDATE edomiProject.editVisuElement SET gaid2=NULL WHERE (gaid2=".$id.")");
		sql_call("UPDATE edomiProject.editAws SET gaid=NULL WHERE (gaid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE (outmode>0 AND outmode<10 AND ((outid=".$id.") OR ((outmode=3 OR outmode=6) AND outvalue=".$id.")))");
		sql_call("DELETE FROM edomiProject.editSceneList WHERE (gaid=".$id.")");
		sql_call("UPDATE edomiProject.editSceneList SET learngaid=NULL WHERE (learngaid=".$id.")");
		sql_call("UPDATE edomiProject.editTimer SET gaid=NULL WHERE (gaid=".$id.")");
		sql_call("UPDATE edomiProject.editTimer SET outgaid=NULL WHERE (outgaid=".$id.")");
		sql_call("UPDATE edomiProject.editAgenda SET gaid=NULL WHERE (gaid=".$id.")");
		sql_call("UPDATE edomiProject.editAgenda SET outgaid=NULL WHERE (outgaid=".$id.")");
		sql_call("UPDATE edomiProject.editArchivCam SET outgaid=NULL WHERE (outgaid=".$id.")");
		sql_call("UPDATE edomiProject.editArchivCam SET outgaid2=NULL WHERE (outgaid2=".$id.")");
		sql_call("UPDATE edomiProject.editArchivKo SET outgaid=NULL WHERE (outgaid=".$id.")");
		sql_call("UPDATE edomiProject.editArchivMsg SET outgaid=NULL WHERE (outgaid=".$id.")");
		sql_call("UPDATE edomiProject.editArchivPhone SET outgaid=NULL WHERE (outgaid=".$id.")");

	} else if ($db=='editScene') {
		sql_call("DELETE FROM edomiProject.editSceneList WHERE (targetid=".$id.")");
		sql_call("DELETE FROM edomiProject.editScene WHERE (id=".$id.")");
		
		//Verweise
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE (outmode=10 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE (outmode=10 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE (outmode=10 AND outid=".$id.")");

	} else if ($db=='editSceneList') {
		sql_call("DELETE FROM edomiProject.editSceneList WHERE (id=".$id.")");

	} else if ($db=='editArchivKo') {
		sql_call("DELETE FROM edomiProject.editArchivKo WHERE (id=".$id.")");
		
		//Verweise
		sql_call("UPDATE edomiProject.editVisuElement SET var1=0 WHERE (var1=".$id." AND controltyp=26)");
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE ((outmode=13 || outmode=40 || outmode=50) AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE ((outmode=13 || outmode=40 || outmode=50) AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE ((outmode=13 || outmode=40 || outmode=50) AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editChartList WHERE (archivkoid=".$id.")");

	} else if ($db=='editArchivMsg') {
		sql_call("DELETE FROM edomiProject.editArchivMsg WHERE (id=".$id.")");

		//Verweise
		sql_call("UPDATE edomiProject.editVisuElement SET var1=0 WHERE (var1=".$id." AND controltyp=25)");
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE ((outmode=14 || outmode=41 || outmode=51) AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE ((outmode=14 || outmode=41 || outmode=51) AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE ((outmode=14 || outmode=41 || outmode=51) AND outid=".$id.")");

	} else if ($db=='editIp') {
		sql_call("DELETE FROM edomiProject.editIp WHERE (id=".$id.")");
		
		//Verweise
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE (outmode=15 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE (outmode=15 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE (outmode=15 AND outid=".$id.")");

	} else if ($db=='editIr') {
		sql_call("DELETE FROM edomiProject.editIr WHERE (id=".$id.")");
		
		//Verweise
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE (outmode=16 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE (outmode=16 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE (outmode=16 AND outid=".$id.")");

	} else if ($db=='editCam') {
		sql_call("DELETE FROM edomiProject.editCam WHERE (id=".$id.")");
		
		//Verweise
		sql_call("UPDATE edomiProject.editVisuElement SET var1=0 WHERE (var1=".$id." AND controltyp=20)");
		sql_call("UPDATE edomiProject.editArchivCam SET camid=0 WHERE (camid=".$id.")");

	} else if ($db=='editArchivCam') {
		sql_call("DELETE FROM edomiProject.editArchivCam WHERE (id=".$id.")");
		
		//Verweise
		sql_call("UPDATE edomiProject.editVisuElement SET var3=0 WHERE (var3=".$id." AND controltyp=20)");
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE ((outmode=12 || outmode=52) AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE ((outmode=12 || outmode=52) AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE ((outmode=12 || outmode=52) AND outid=".$id.")");

	} else if ($db=='editSequence') {
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE (targetid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequence WHERE (id=".$id.")");
		
		//Verweise
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE (outmode=11 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE (outmode=11 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE (outmode=11 AND outid=".$id.")");

	} else if ($db=='editTimer') {
		sql_call("DELETE FROM edomiProject.editTimerData WHERE (targetid=".$id.")");
		sql_call("DELETE FROM edomiProject.editTimer WHERE (id=".$id.")");
		
		//Verweise
		sql_call("UPDATE edomiProject.editVisuElement SET var1=0 WHERE (var1=".$id." AND controltyp=22)");

	} else if ($db=='editAgenda') {
		sql_call("DELETE FROM edomiProject.editAgendaData WHERE (targetid=".$id.")");
		sql_call("DELETE FROM edomiProject.editAgenda WHERE (id=".$id.")");
		
		//Verweise
		sql_call("UPDATE edomiProject.editVisuElement SET var1=0 WHERE (var1=".$id." AND controltyp=32)");

	} else if ($db=='editAws') {
		sql_call("DELETE FROM edomiProject.editAwsList WHERE (targetid=".$id.")");
		sql_call("DELETE FROM edomiProject.editAws WHERE (id=".$id.")");
		
		//Verweise
		sql_call("UPDATE edomiProject.editVisuElement SET var1=0 WHERE (var1=".$id." AND controltyp=23)");

	} else if ($db=='editEmail') {
		sql_call("DELETE FROM edomiProject.editEmail WHERE (id=".$id.")");
		
		//Verweise
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE (outmode=20 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE (outmode=20 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE (outmode=20 AND outid=".$id.")");

	} else if ($db=='editPhoneBook') {
		sql_call("DELETE FROM edomiProject.editPhoneBook WHERE (id=".$id.")");
		
		//Verweise
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE (outmode=22 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE (outmode=22 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE (outmode=22 AND outid=".$id.")");

	} else if ($db=='editPhoneCall') {
		sql_call("DELETE FROM edomiProject.editPhoneCall WHERE (id=".$id.")");

		//Verweise gibt es nicht

	} else if ($db=='editArchivPhone') {
		sql_call("DELETE FROM edomiProject.editArchivPhone WHERE (id=".$id.")");
		
		//Verweise
		sql_call("UPDATE edomiProject.editVisuElement SET var1=0 WHERE (var1=".$id." AND controltyp=28)");
		sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE (outmode=53 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE (outmode=53 AND outid=".$id.")");
		sql_call("DELETE FROM edomiProject.editSequenceList WHERE (outmode=53 AND outid=".$id.")");

	} else if ($db=='editChart') {
		sql_call("DELETE FROM edomiProject.editChartList WHERE (targetid=".$id.")");
		sql_call("DELETE FROM edomiProject.editChart WHERE (id=".$id.")");
		
		//Verweise
		sql_call("UPDATE edomiProject.editVisuElement SET var1=0 WHERE (var1=".$id." AND controltyp=21)");

	} else if ($db=='editHttpKo') {
		sql_call("DELETE FROM edomiProject.editHttpKo WHERE (id=".$id.")");
		
		//Verweise gibt es nicht

	} else if ($db=='editVisuElementDesign') {
		//Visuelement: Design löschen
		sql_call("DELETE FROM edomiProject.editVisuElementDesign WHERE (id=".$id.")");

		//Verweise gibt es nicht
		
	} else if ($db=='editLogicCmdList' || $db=='editVisuCmdList' || $db=='editSequenceList') {
		sql_call("DELETE FROM edomiProject.".$db." WHERE (id=".$id.")");

		//Verweise gibt es nicht
		
	} else if ($db=='editChartList') {
		sql_call("DELETE FROM edomiProject.editChartList WHERE (id=".$id.")");

		//Verweise gibt es nicht
		
	} else if ($db=='editAwsList') {
		sql_call("DELETE FROM edomiProject.editAwsList WHERE (id=".$id.")");

		//Verweise gibt es nicht
		
	} else if ($db=='editVisuUserList') {
		sql_call("DELETE FROM edomiProject.editVisuUserList WHERE (id=".$id.")");

		//Verweise gibt es nicht
		
	} else if ($db=='editTimerData') {
		sql_call("DELETE FROM edomiProject.editTimerData WHERE (id=".$id.")");

		//Verweise gibt es nicht

	} else if ($db=='editAgendaData') {
		sql_call("DELETE FROM edomiProject.editAgendaData WHERE (id=".$id.")");

		//Verweise gibt es nicht

	} else if ($db=='editLogicElement') {
		sql_call("DELETE FROM edomiProject.editLogicElement WHERE (id=".$id.")");

		//Verweise
		sql_call("UPDATE edomiProject.editLogicLink SET linktyp=2,linkid=null,ausgang=null WHERE (linktyp=1 AND linkid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicLink WHERE (elementid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicElementVar WHERE (elementid=".$id.")");
		sql_call("DELETE FROM edomiProject.editLogicCmdList WHERE (targetid=".$id.")");
		
	}
}


//---------------------------------------------------------------------------------------------------------------------------------------------
//Elemente: Duplizieren
//---------------------------------------------------------------------------------------------------------------------------------------------

function db_itemDuplicate($db,$id,$targetFolderId=0,$nameSuffix='') {
	//Element einschließlich aller Abhängigkeiten duplizieren
	
	if ($db=='editPhoneCall') {
		$ss1=sql_call("SELECT * FROM edomiProject.editPhoneCall WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {			
			sql_call("INSERT INTO edomiProject.editPhoneCall (name,folderid,phoneid1,phoneid2,gaid1,gaid2,gaid3,typ) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".$original['phoneid1']."',
				'".$original['phoneid2']."',
				'".$original['gaid1']."',
				'".$original['gaid2']."',
				'".$original['gaid3']."',
				'".$original['typ']."'
			)");						
			$dbId=sql_insertId();
			return $dbId;
		}

	} else if ($db=='editEmail') {
		$ss1=sql_call("SELECT * FROM edomiProject.editEmail WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {			
			sql_call("INSERT INTO edomiProject.editEmail (name,folderid,mailaddr,subject,body) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				".sql_encodeValue($original['mailaddr'],true).",
				".sql_encodeValue($original['subject'],true).",
				".sql_encodeValue($original['body'],true)."
			)");	
			$dbId=sql_insertId();
			return $dbId;
		}

	} else if ($db=='editIr') {
		$ss1=sql_call("SELECT * FROM edomiProject.editIr WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {			
			sql_call("INSERT INTO edomiProject.editIr (name,folderid,data,info) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				".sql_encodeValue($original['data'],true).",
				".sql_encodeValue($original['info'],true)."
			)");						
			$dbId=sql_insertId();
			return $dbId;
		}

	} else if ($db=='editCam') {
		$ss1=sql_call("SELECT * FROM edomiProject.editCam WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {			
			sql_call("INSERT INTO edomiProject.editCam (name,folderid,datetime,url,mjpeg,mask) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".$original['datetime']."',
				".sql_encodeValue($original['url'],true).",
				'".$original['mjpeg']."',
				'".$original['mask']."'
			)");						
			$dbId=sql_insertId();
			return $dbId;
		}

	} else if ($db=='editIp') {
		$ss1=sql_call("SELECT * FROM edomiProject.editIp WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {			
			sql_call("INSERT INTO edomiProject.editIp (name,folderid,url,iptyp,httperrlog,httptimeout,udpraw,outgaid,outgaid2,data) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				".sql_encodeValue($original['url'],true).",
				'".$original['iptyp']."',
				'".$original['httperrlog']."',
				'".$original['httptimeout']."',
				'".$original['outgaid']."',
				'".$original['outgaid2']."',
				'".$original['udpraw']."',
				".sql_encodeValue($original['data'],true)."
			)");						
			$dbId=sql_insertId();
			return $dbId;
		}

	} else if ($db=='editArchivMsg') {
		$ss1=sql_call("SELECT * FROM edomiProject.editArchivMsg WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {			
			sql_call("INSERT INTO edomiProject.editArchivMsg (name,folderid,keep,delay,outgaid) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".$original['keep']."',
				'".$original['delay']."',
				'".$original['outgaid']."'
			)");						
			$dbId=sql_insertId();
			return $dbId;
		}

	} else if ($db=='editArchivKo') {
		$ss1=sql_call("SELECT * FROM edomiProject.editArchivKo WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {			
			sql_call("INSERT INTO edomiProject.editArchivKo (name,folderid,keep,delay,outgaid) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".$original['keep']."',
				'".$original['delay']."',
				'".$original['outgaid']."'
			)");						
			$dbId=sql_insertId();
			return $dbId;
		}

	} else if ($db=='editArchivPhone') {
		$ss1=sql_call("SELECT * FROM edomiProject.editArchivPhone WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {			
			sql_call("INSERT INTO edomiProject.editArchivPhone (name,folderid,keep,outgaid) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".$original['keep']."',
				'".$original['outgaid']."'
			)");						
			$dbId=sql_insertId();
			return $dbId;
		}
	
	} else if ($db=='editArchivCam') {
		$ss1=sql_call("SELECT * FROM edomiProject.editArchivCam WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {			
			sql_call("INSERT INTO edomiProject.editArchivCam (name,folderid,camid,keep,delay,outgaid,outgaid2) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".$original['camid']."',
				'".$original['keep']."',
				'".$original['delay']."',
				'".$original['outgaid']."',
				'".$original['outgaid2']."'
			)");						
			$dbId=sql_insertId();
			return $dbId;
		}

	} else if ($db=='editKo') {
		$ss1=sql_call("SELECT * FROM edomiProject.editKo WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {			
			if ($original['gatyp']==2) {	//nur KOs können dupliziert werden (keine KNX-GAs)!
				sql_call("INSERT INTO edomiProject.editKo (name,folderid,ga,gatyp,valuetyp,value,defaultvalue,initscan,initsend,requestable,remanent,vmin,vmax,vstep,vlist,vcsv,text) VALUES (
					'".sql_encodeValue($original['name'].$nameSuffix)."',
					'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
					'',
					'".$original['gatyp']."',
					'".$original['valuetyp']."',
					".sql_encodeValue($original['value'],true).",
					".sql_encodeValue($original['defaultvalue'],true).",
					'".$original['initscan']."',
					'".$original['initsend']."',
					'".$original['requestable']."',
					'".$original['remanent']."',
					".sql_encodeValue($original['vmin'],true).",
					".sql_encodeValue($original['vmax'],true).",
					".sql_encodeValue($original['vstep'],true).",
					".sql_encodeValue($original['vlist'],true).",
					".sql_encodeValue($original['vcsv'],true).",
					".sql_encodeValue($original['text'],true)."
				)");			
				$dbId=sql_insertId();				
				if ($dbId>0) {
					//internes KO: GA=neue ID
					sql_call("UPDATE edomiProject.editKo SET ga='".$dbId."' WHERE (id=".$dbId.")");
				}
				return $dbId;
			}
		}

	} else if ($db=='editScene') {
		$ss1=sql_call("SELECT * FROM edomiProject.editScene WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {

			sql_call("INSERT INTO edomiProject.editScene (name,folderid) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."'
			)");
			$dbId=sql_insertId();				
			if ($dbId>0) {
				$ss2=sql_call("SELECT * FROM edomiProject.editSceneList WHERE (targetid=".$original['id'].") ORDER BY id ASC");
				while ($n=sql_result($ss2)) {
					sql_call("INSERT INTO edomiProject.editSceneList (targetid,gaid,gavalue,learngaid) VALUES (
						'".$dbId."',
						'".$n['gaid']."',
						".sql_encodeValue($n['gavalue'],true).",
						'".$n['learngaid']."'
					)");
				}
			}
			return $dbId;			
		}

	} else if ($db=='editChart') {
		$ss1=sql_call("SELECT * FROM edomiProject.editChart WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {

			sql_call("INSERT INTO edomiProject.editChart (name,folderid,titel,datefrom,dateto,mode,xunit,xinterval,ymin,ymax,ynice,yticks) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".sql_encodeValue($original['titel'])."',
				'".sql_encodeValue($original['datefrom'])."',
 				'".sql_encodeValue($original['dateto'])."',
	 			'".$original['mode']."',
	 			'".$original['xunit']."',
 				".sql_encodeValue($original['xinterval'],true).",
				".sql_encodeValue($original['ymin'],true).",
				".sql_encodeValue($original['ymax'],true).",
				".sql_encodeValue($original['ynice'],true).",
				".sql_encodeValue($original['yticks'],true)."
			)");
			$dbId=sql_insertId();				
			if ($dbId>0) {
				$ss2=sql_call("SELECT * FROM edomiProject.editChartList WHERE (targetid=".$original['id'].") ORDER BY id ASC");
				while ($n=sql_result($ss2)) {
					sql_call("INSERT INTO edomiProject.editChartList (targetid,archivkoid,titel,charttyp,ymin,ymax,ystyle,s1,s2,s3,s4,ygrid1,ygrid2,ygrid3,yshow,ynice,yticks,charttyp2,ss1,ss2,ss3,ss4,xinterval,yminmax,extend1,extend2,yshowvalue,yscale) VALUES (
						'".$dbId."',
						'".$n['archivkoid']."',
						'".sql_encodeValue($n['titel'])."',
						'".$n['charttyp']."',
						".sql_encodeValue($n['ymin'],true).",
						".sql_encodeValue($n['ymax'],true).",
						'".$n['ystyle']."',
						'".$n['s1']."',
						'".$n['s2']."',
						'".$n['s3']."',
						'".$n['s4']."',
						".sql_encodeValue($n['ygrid1'],true).",
						".sql_encodeValue($n['ygrid2'],true).",
						".sql_encodeValue($n['ygrid3'],true).",
						".sql_encodeValue($n['yshow'],true).",
						".sql_encodeValue($n['ynice'],true).",
						".sql_encodeValue($n['yticks'],true).",
						'".$n['charttyp2']."',
						'".$n['ss1']."',
						'".$n['ss2']."',
						'".$n['ss3']."',
						'".$n['ss4']."',
						'".$n['xinterval']."',
						'".$n['yminmax']."',
						'".$n['extend1']."',
						'".$n['extend2']."',
						'".$n['yshowvalue']."',
						".sql_encodeValue($n['yscale'],true)."
					)");
				}
			}
			return $dbId;			
		}

	} else if ($db=='editAws') {
		$ss1=sql_call("SELECT * FROM edomiProject.editAws WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {

			sql_call("INSERT INTO edomiProject.editAws (name,folderid,gaid,recordpointer,playpointer,checkpointer) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".$original['gaid']."',
				".sql_encodeValue($original['recordpointer'],true).",
				".sql_encodeValue($original['playpointer'],true).",
				".sql_encodeValue($original['checkpointer'],true)."
			)");
			$dbId=sql_insertId();				
			if ($dbId>0) {
				$ss2=sql_call("SELECT * FROM edomiProject.editAwsList WHERE (targetid=".$original['id'].") ORDER BY id ASC");
				while ($n=sql_result($ss2)) {
					sql_call("INSERT INTO edomiProject.editAwsList (targetid,gaid) VALUES (
						'".$dbId."',
						'".$n['gaid']."'
					)");
				}
			}
			return $dbId;			
		}

	} else if ($db=='editTimer') {
		$ss1=sql_call("SELECT * FROM edomiProject.editTimer WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {

			sql_call("INSERT INTO edomiProject.editTimer (name,folderid,gaid,outgaid) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".$original['gaid']."',
				'".$original['outgaid']."'
			)");
			$dbId=sql_insertId();				
			if ($dbId>0) {
				$ss2=sql_call("SELECT * FROM edomiProject.editTimerData WHERE (targetid=".$original['id'].") ORDER BY id ASC");
				while ($n=sql_result($ss2)) {
					sql_call("INSERT INTO edomiProject.editTimerData (targetid,fixed,status,hour,minute,day1,day2,month1,month2,year1,year2,d0,d1,d2,d3,d4,d5,d6) VALUES (
						'".$dbId."',
						'".$n['fixed']."',
						".sql_encodeValue($n['status'],true).",
						'".sql_encodeValue($n['hour'])."',
						'".sql_encodeValue($n['minute'])."',
						".sql_encodeValue($n['day1'],true).",
						".sql_encodeValue($n['day2'],true).",
						".sql_encodeValue($n['month1'],true).",
						".sql_encodeValue($n['month2'],true).",
						".sql_encodeValue($n['year1'],true).",
						".sql_encodeValue($n['year2'],true).",
						'".sql_encodeValue($n['d0'])."',
						'".sql_encodeValue($n['d1'])."',
						'".sql_encodeValue($n['d2'])."',
						'".sql_encodeValue($n['d3'])."',
						'".sql_encodeValue($n['d4'])."',
						'".sql_encodeValue($n['d5'])."',
						'".sql_encodeValue($n['d6'])."'
					)");
				}
			}
			return $dbId;			
		}

	} else if ($db=='editAgenda') {
		$ss1=sql_call("SELECT * FROM edomiProject.editAgenda WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {

			sql_call("INSERT INTO edomiProject.editAgenda (name,folderid,gaid,outgaid) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".$original['gaid']."',
				'".$original['outgaid']."'
			)");
			$dbId=sql_insertId();				
			if ($dbId>0) {
				$ss2=sql_call("SELECT * FROM edomiProject.editAgendaData WHERE (targetid=".$original['id'].") ORDER BY id ASC");
				while ($n=sql_result($ss2)) {
					sql_call("INSERT INTO edomiProject.editAgendaData (targetid,name,fixed,status,hour,minute,date1,date2,step,unit) VALUES (
						'".$dbId."',
						'".sql_encodeValue($n['name'])."',
						'".$n['fixed']."',
						".sql_encodeValue($n['status'],true).",
						".sql_encodeValue($n['hour'],true).",
						".sql_encodeValue($n['minute'],true).",
						".sql_encodeValue($n['date1'],true).",
						".sql_encodeValue($n['date2'],true).",
						'".sql_encodeValue($n['step'])."',
						'".sql_encodeValue($n['unit'])."'
					)");
				}
			}
			return $dbId;			
		}

	} else if ($db=='editSequence') {
		$ss1=sql_call("SELECT * FROM edomiProject.editSequence WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {

			sql_call("INSERT INTO edomiProject.editSequence (name,folderid,datetime,ms,playpointer) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				".sql_encodeValue($original['datetime'],true).",
				".sql_encodeValue($original['ms'],true).",
				".sql_encodeValue($original['playpointer'],true)."
			)");
			$dbId=sql_insertId();				
			if ($dbId>0) {
				$ss2=sql_call("SELECT * FROM edomiProject.editSequenceList WHERE (targetid=".$original['id'].") ORDER BY id ASC");
				while ($n=sql_result($ss2)) {
					sql_call("INSERT INTO edomiProject.editSequenceList (targetid,outmode,outid,outvalue,delay,sort) VALUES (
						'".$dbId."',
						'".$n['outmode']."',
						".sql_encodeValue($n['outid'],true).",
						".sql_encodeValue($n['outvalue'],true).",
						'".sql_encodeValue($n['delay'])."',
						'".$n['sort']."'
					)");
				}
			}
			return $dbId;			
		}

	} else if ($db=='editVisu') {	
		//Hilfsvariablen löschen
		sql_call("UPDATE edomiProject.editRoot SET tmp=NULL");
		sql_call("UPDATE edomiProject.editVisuPage SET tmp=NULL");

		$original=sql_getValues('edomiProject.editVisu','*','id='.$id);
		if ($original!==false) {

			//Visu kopieren
			sql_call("INSERT INTO edomiProject.editVisu (name,folderid,xsize,ysize,defaultpageid,sspageid,sstimeout,indicolor,indicolor2) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".sql_encodeValue($original['xsize'])."',
				'".sql_encodeValue($original['ysize'])."',
				'".$original['defaultpageid']."',
				'".$original['sspageid']."',
				'".$original['sstimeout']."',
				'".$original['indicolor']."',
				'".$original['indicolor2']."'
			)");
			$dbId=sql_insertId();				
			if ($dbId>0) {

				//Ordnerstruktur duplizieren
				$ss2=sql_call("SELECT * FROM edomiProject.editRoot WHERE (link=22 AND linkid=".$original['id'].") ORDER BY ((LENGTH(path)-LENGTH(REPLACE(path,'/','')))-1) ASC,id ASC");	//alle Ordner der Visu holen, sortiert nach Anzahl der / im path (tricky...)
				while ($originalFolder=sql_result($ss2)) {
					$parentId=22;
					if ($originalFolder['parentid']!=$parentId) {$parentId=sql_getValue('edomiProject.editRoot','id','tmp='.$originalFolder['parentid']);}

					db_itemSave('editRoot',array(
						1	=>	-1,
						2	=>	$originalFolder['name'],
						3	=>	$parentId,
						4	=>	$dbId,
						5	=>	$originalFolder['id']
					));
				}
				sql_close($ss2);

				//Visuseiten kopieren
				$ss2=sql_call("SELECT * FROM edomiProject.editVisuPage WHERE (visuid=".$original['id'].") ORDER BY id ASC");
				while ($n=sql_result($ss2)) {
					if ($n['folderid']==22) {
						//Seite kopieren (mit Root-FolderID)
						db_itemDuplicate_editVisuPage(true,$n['id'],$dbId,22,'');
					} else {
						//neue FolderID holen
						$tmp=sql_getValues('edomiProject.editRoot','id','link=22 AND linkid='.$dbId.' AND tmp='.$n['folderid']);
						if ($tmp!==false) {
							//Seite kopieren (mit neuer FolderID)
							db_itemDuplicate_editVisuPage(true,$n['id'],$dbId,$tmp['id'],'');
						}
					}
				}
				sql_close($ss2);

				//Visu: Verweise korrigieren (visu.defaultpageid, visu.sspageid)
				$n=sql_getValues('edomiProject.editVisu','*','id='.$dbId);
				if ($n!==false) {
					if ($n['defaultpageid']>0) {
						$tmp=sql_getValue('edomiProject.editVisuPage','id','(visuid='.$dbId.' AND tmp='.$n['defaultpageid'].')');				
						sql_call("UPDATE edomiProject.editVisu SET defaultpageid=".sql_encodeValue($tmp,true)." WHERE (id=".$dbId.")");
					}					
					if ($n['sspageid']>0) {
						$tmp=sql_getValue('edomiProject.editVisuPage','id','(visuid='.$dbId.' AND tmp='.$n['sspageid'].')');
						sql_call("UPDATE edomiProject.editVisu SET sspageid=".sql_encodeValue($tmp,true)." WHERE (id=".$dbId.")");
					}
				}				

				//Visuseiten: Verweise korrigieren (visuPages.includeid)
				$ss2=sql_call("SELECT * FROM edomiProject.editVisuPage WHERE (visuid=".$dbId." AND includeid>0)");
				while ($n=sql_result($ss2)) {
					$tmp=sql_getValue('edomiProject.editVisuPage','id','(visuid='.$dbId.' AND tmp='.$n['includeid'].')');		
					sql_call("UPDATE edomiProject.editVisuPage SET includeid=".sql_encodeValue($tmp,true)." WHERE (id=".$n['id']." AND visuid=".$dbId.")");
				}				
				sql_close($ss2);

				//Visu-Elemente: Verweise korrigieren (visuElement.gotopageid)
				$ss2=sql_call("SELECT * FROM edomiProject.editVisuElement WHERE (visuid=".$dbId." AND gotopageid>0)");
				while ($n=sql_result($ss2)) {
					$tmp=sql_getValue('edomiProject.editVisuPage','id','(visuid='.$dbId.' AND tmp='.$n['gotopageid'].')');		
					sql_call("UPDATE edomiProject.editVisuElement SET gotopageid=".sql_encodeValue($tmp,true)." WHERE (id=".$n['id']." AND visuid=".$dbId.")");
				}				
				sql_close($ss2);

				//Account-Zuweisungen kopieren
				$ss2=sql_call("SELECT * FROM edomiProject.editVisuUserList WHERE (visuid=".$original['id'].")");
				while ($n=sql_result($ss2)) {
					sql_call("INSERT INTO edomiProject.editVisuUserList (targetid,visuid,visuinit,visupageid,visusoundid,visuspeech,logindate,logoutdate,actiondate,loginip,sid) VALUES (
						'".$n['targetid']."',
						'".$dbId."',
						NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL
					)");
				}
				sql_close($ss2);
			}
			return $dbId;			
		}

	} else if ($db=='editVisuPage') {
		$dbId=db_itemDuplicate_editVisuPage(false,$id,0,$targetFolderId,$nameSuffix);
		return $dbId;

	} else if ($db=='editVisuElementDef') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDef WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {		
			$insertC='';
			$insertV='';
			for ($tt=1;$tt<=48;$tt++) {
				$insertC.="s".$tt.",";
				$insertV.=sql_encodeValue($original['s'.$tt],true).',';
			}		
			sql_call("INSERT INTO edomiProject.editVisuElementDef (name,folderid,styletyp,".rtrim($insertC,',').") VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				".$original['styletyp'].",
				".rtrim($insertV,',')."
			)");
			$dbId=sql_insertId();				
			return $dbId;			
		}

	} else if ($db=='editVisuBGcol') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuBGcol WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {			
			sql_call("INSERT INTO edomiProject.editVisuBGcol (name,folderid,color) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".sql_encodeValue($original['color'])."'
			)");						
			$dbId=sql_insertId();				
			return $dbId;			
		}

	} else if ($db=='editVisuFGcol') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuFGcol WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {			
			sql_call("INSERT INTO edomiProject.editVisuFGcol (name,folderid,color) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".sql_encodeValue($original['color'])."'
			)");						
			$dbId=sql_insertId();				
			return $dbId;			
		}

	} else if ($db=='editVisuAnim') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuAnim WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {			
			sql_call("INSERT INTO edomiProject.editVisuAnim (name,folderid,keyframes) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".sql_encodeValue($original['keyframes'])."'
			)");						
			$dbId=sql_insertId();				
			return $dbId;			
		}

	} else if ($db=='editVisuUser') {
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuUser WHERE (id=".$id.")");
		if ($original=sql_result($ss1)) {			
			sql_call("INSERT INTO edomiProject.editVisuUser (login,folderid,pass,gaid,gaid2,gaid3,touch,touchscroll,autologout) VALUES (
				'".sql_encodeValue($original['login'].$nameSuffix)."',
				'".(($targetFolderId>0)?$targetFolderId:$original['folderid'])."',
				'".sql_encodeValue($original['pass'])."',
				'".$original['gaid']."',
				'".$original['gaid2']."',
				'".$original['gaid3']."',
				'".$original['touch']."',
				'".$original['touchscroll']."',
				'".$original['autologout']."'
			)");						
			$dbId=sql_insertId();				
			return $dbId;			
		}

	} else if ($db=='editVisuElementDesign') {
		//app1003 (Kontextmenü): dynamisches Design eines Visuelements duplizieren
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDesign WHERE id=".$id." AND styletyp=1");
		if ($original=sql_result($ss1)) {
			$insertC='';
			$insertV='';
			for ($t=1;$t<=48;$t++) {
				$insertC.="s".$t.",";
				$insertV.=sql_encodeValue($original['s'.$t],true).',';
			}								
			sql_call("INSERT INTO edomiProject.editVisuElementDesign (targetid,defid,styletyp,".rtrim($insertC,',').") VALUES (
				".$original['targetid'].",
				'".$original['defid']."',
				".$original['styletyp'].",
				".rtrim($insertV,',')."
			)");
			$dbId=sql_insertId();				
			return $dbId;			
		}
		sql_close($ss1);

	}
	return false;
}

function db_itemDuplicate_editVisuPage($mode,$pageId,$visuId,$folderId,$nameSuffix='') {
	//$mode: false=einzelne Seite duplizieren, true=ganze Visu duplizieren
	//wenn $mode=false:
	//		$visuId: (wird ignoriert)
	//		$folderId: >0=diese FolderId beim INSERT verwenden, 0=Original-FolderId verwenden
	//		$nameSuffix: z.B. "-KOPIE"
	//wenn $mode=true:
	//		$visuId: diese visuId beim INSERT verwenden 
	//		$folderId: diese FolderId beim INSERT verwenden
	//		$nameSuffix: z.B. "-KOPIE" (sollte hier normalerweise leer sein)
	//return: ID der neuen (duplizierten) Seite
	
	$ss1=sql_call("SELECT * FROM edomiProject.editVisuPage WHERE (id=".$pageId.")");
	if ($original=sql_result($ss1)) {

		if ($mode) {
			$newVisuId=$visuId;
			//visuPage kopieren (Original-ID in tmp merken)
			sql_call("INSERT INTO edomiProject.editVisuPage (name,folderid,visuid,includeid,globalinclude,pagetyp,xpos,ypos,xsize,ysize,autoclose,bgcolorid,bgimg,xgrid,ygrid,tmp) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".$folderId."',
				'".$visuId."',
				'".$original['includeid']."',
				'".$original['globalinclude']."',
				'".$original['pagetyp']."',
				".sql_encodeValue($original['xpos'],true).",
				".sql_encodeValue($original['ypos'],true).",
				".sql_encodeValue($original['xsize'],true).",
				".sql_encodeValue($original['ysize'],true).",
				'".$original['autoclose']."',
				'".$original['bgcolorid']."',
				'".$original['bgimg']."',
				'".sql_encodeValue($original['xgrid'])."',
				'".sql_encodeValue($original['ygrid'])."',
				'".$original['id']."'
			)");
		} else {
			$newVisuId=$original['visuid'];
			//visuPage kopieren
			sql_call("INSERT INTO edomiProject.editVisuPage (name,folderid,visuid,includeid,globalinclude,pagetyp,xpos,ypos,xsize,ysize,autoclose,bgcolorid,bgimg,xgrid,ygrid) VALUES (
				'".sql_encodeValue($original['name'].$nameSuffix)."',
				'".(($folderId>0)?$folderId:$original['folderid'])."',
				'".$original['visuid']."',
				'".$original['includeid']."',
				'".$original['globalinclude']."',
				'".$original['pagetyp']."',
				".sql_encodeValue($original['xpos'],true).",
				".sql_encodeValue($original['ypos'],true).",
				".sql_encodeValue($original['xsize'],true).",
				".sql_encodeValue($original['ysize'],true).",
				'".$original['autoclose']."',
				'".$original['bgcolorid']."',
				'".$original['bgimg']."',
				'".sql_encodeValue($original['xgrid'])."',
				'".sql_encodeValue($original['ygrid'])."'
			)");
		}
		$dbId=sql_insertId();
		if ($dbId>0) {	
			//Visuelemente kopieren
			$elementIds=array();
			$ss1=sql_call("SELECT id FROM edomiProject.editVisuElement WHERE (visuid=".$original['visuid']." AND pageid=".$original['id'].") ORDER BY id ASC");
			while ($n=sql_result($ss1)) {
				$elementIds[]=$n['id'];
			}
			sql_close($ss1);			
			db_itemDuplicate_editVisuElement($newVisuId,$dbId,$elementIds,'');	
		}
		return $dbId;
		
	}
}

function db_itemDuplicate_editVisuElement($visuId,$pageId,$elementIds,$nameSuffix='') {
	//Visuelemente duplizieren
	//$visuId: VisuID des neuen Visuelements
	//$pageId: PageID des neuen Visuelements 
	//$elementIds: Array der zu duplizierenden Element-IDs
	//return: Array mit den neuen (duplizierten) Element-IDs (einschließlich Gruppen-Elemente)
	
	$r=array();
		
	//Hilfsfeld löschen
	sql_call("UPDATE edomiProject.editVisuElement SET tmp=NULL");

	foreach ($elementIds as $element) {
		if ($element>0) {
			$n=sql_getValues('edomiProject.editVisuElement','*','id='.$element);
			if ($n!==false) {
			
				if ($n['controltyp']==255) {
					//Gruppenelement: neue Gruppe anlegen
					//alte ID merken (tmp)! Später müssen die kopierten Elemente auf diese groupid gesetzt werden...
					$dbId=db_itemSave('editVisuElement',array(
						1	=>	-1,
						6	=>	255,
						20	=>	$n['name'].$nameSuffix,
						97	=>	$visuId,
						98	=>	$pageId,
						99	=>	$n['id']
					));
					
					if ($dbId>0) {
						$r[]=$dbId;
					}
				} else {
					//normales Element: kopieren (groupid wird erstmal übernommen - wird später ggf. korrigiert)
					//(tmp=0 setzen, um das neue Element vom Original zu unterscheiden!)
					$dbId=db_itemSave('editVisuElement',array(
						1	=>	-1,
						2	=>	$n['xpos'],
						3	=>	$n['ypos'],
						6	=>	$n['controltyp'],
						7	=>	$n['gaid'],
						8	=>	$n['zindex'],
						13	=>	$n['gotopageid'],
						14	=>	$n['closepopup'],
						15	=>	$n['xsize'],
						16	=>	$n['ysize'],
						17	=>	$n['gaid2'],
						18	=>	$n['text'],
						19	=>	$n['initonly'],
						20	=>	((!isEmpty($n['name']))?$n['name'].$nameSuffix:''),
						21	=>	$n['groupid'],
						31	=>	$n['var1'],
						32	=>	$n['var2'],
						33	=>	$n['var3'],
						34	=>	$n['var4'],
						35	=>	$n['var5'],
						36	=>	$n['var6'],
						37	=>	$n['var7'],
						38	=>	$n['var8'],
						39	=>	$n['var9'],
						40	=>	$n['var10'],
						96	=>	$n['galive'],
						97	=>	$visuId,
						98	=>	$pageId,
						99	=>	0
					));
					
					if ($dbId>0) {
						//Befehle kopieren (mit der neuen ID)
						$ss1=sql_call("SELECT * FROM edomiProject.editVisuCmdList WHERE (targetid=".$element.") ORDER BY id ASC");
						while ($nn=sql_result($ss1)) {
							sql_call("INSERT INTO edomiProject.editVisuCmdList (targetid,outmode,outid,outvalue) VALUES ('".$dbId."','".$nn['outmode']."','".$nn['outid']."',".sql_encodeValue($nn['outvalue'],true).")");
						}
						sql_close($ss1);
			
						//Designs kopieren (mit der neuen ID)
						$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDesign WHERE (targetid=".$element.") ORDER BY id ASC");
						while ($nn=sql_result($ss1)) {
							$insertC='';
							$insertV='';
							for ($tt=1;$tt<=48;$tt++) {
								$insertC.="s".$tt.",";
								$insertV.=sql_encodeValue($nn['s'.$tt],true).',';
							}		
							sql_call("INSERT INTO edomiProject.editVisuElementDesign (targetid,defid,styletyp,".rtrim($insertC,',').") VALUES ('".$dbId."','".$nn['defid']."',".$nn['styletyp'].",".rtrim($insertV,',').")");
						}
						sql_close($ss1);
						
						$r[]=$dbId;
					}
				}

			}					
		}
	}

	//groupid der duplizierten Elemente korrigieren (und tmp auf neue groupid setzen - als Markierung)
	$ss1=sql_call("SELECT * FROM edomiProject.editVisuElement WHERE (pageid='.$pageId.' AND controltyp=255 AND (tmp is NOT NULL))");
	while ($n=sql_result($ss1)) {
		sql_call("UPDATE edomiProject.editVisuElement SET groupid=".$n['id'].",tmp=NULL WHERE (groupid=".$n['tmp']." AND tmp=0 AND controltyp<>255)");
	}
	sql_close($ss1);

	//groupid bei duplizierten Elemente ohne zugehörige Gruppe löschen
	sql_call("UPDATE edomiProject.editVisuElement set groupid=0 WHERE (pageid='.$pageId.' AND controltyp<>255 AND tmp=0)");
	
	//Hilfsfeld löschen
	sql_call("UPDATE edomiProject.editVisuElement SET tmp=NULL");

	return $r;
}

function db_itemDuplicate_editLogicElement($pageId,$elementIds) {
	//Logikelement-Instanzen(!) duplizieren (es werden nur die Verbindungen innerhalb(!) der $elementIds übernommen)
	//$pageId: PageID des neuen Logikelements 
	//$elementIds: Array der zu duplizierenden Element-IDs
	//return: Array mit den neuen (duplizierten) Element-IDs
	
	$r=array();
	$copyIds=array();
		
	for ($t=0; $t<count($elementIds); $t++) {
		//LBS-Instanz duplizieren
		$dbId=0;
		$n=sql_getValues('edomiProject.editLogicElement','*','id='.$elementIds[$t]);
		if ($n!==false) {
			if ($pageId==$n['pageid']) {$offset=15;} else {$offset=0;}	//wenn Elemente auf der gleichen Seite eingefügt werden: Position leicht verschieben
			$dbId=sql_save('edomiProject.editLogicElement',null,array(
				'functionid'	=>	$n['functionid'],
				'pageid'		=>	$pageId,
				'xpos'			=>	($n['xpos']+$offset),
				'ypos'			=>	($n['ypos']+$offset),
				'name'			=>	"'".sql_encodeValue($n['name'])."'"
			));

			if ($dbId>0) {
			
				//Variablen duplizieren
				$ss1=sql_call("SELECT * FROM edomiProject.editLogicElementVar WHERE (elementid=".$elementIds[$t].")");
				while ($nn=sql_result($ss1)) {
					sql_call("INSERT INTO edomiProject.editLogicElementVar (elementid,varid,value) VALUES (
						'".$dbId."',
						'".$nn['varid']."',
						".sql_encodeValue($nn['value'],true)."
					)");
				}
				sql_close($ss1);

				//Befehle duplizieren
				$ss1=sql_call("SELECT * FROM edomiProject.editLogicCmdList WHERE (targetid=".$elementIds[$t].") ORDER BY id ASC");
				while ($nn=sql_result($ss1)) {
					sql_call("INSERT INTO edomiProject.editLogicCmdList (targetid,outmode,outid,outvalue) VALUES (
						'".$dbId."',
						'".$nn['outmode']."',
						'".$nn['outid']."',
						".sql_encodeValue($nn['outvalue'],true)."
					)");
				}
				sql_close($ss1);
		
				$r[]=$dbId;
			}
		}
		$copyIds[$t]=$dbId;
	}


	//Eingänge duplizieren
	for ($t=0; $t<count($elementIds); $t++) {

		$ss1=sql_call("SELECT * FROM edomiProject.editLogicLink WHERE (elementid=".$elementIds[$t].")");
		while ($n=sql_result($ss1)) {

			//Verbindung vorhanden?
			if ($n['linktyp']=='1') {

				//besteht die Verbindung innerhalb der markierten Elemente?
				$id=array_search($n['linkid'],$elementIds);
				if ($id===false) { //Verbindung ist außerhalb => entfernen
					sql_call("INSERT INTO edomiProject.editLogicLink (elementid,eingang,linktyp,linkid,ausgang,refresh,value) VALUES (
						'".$copyIds[$t]."',
						'".$n['eingang']."',
						'2',null,null,
						'".$n['refresh']."',
						".sql_encodeValue($n['value'],true)."
					)");

				} else { //Verbindung ist innerhalb => linkid auf neue ID setzen
					sql_call("INSERT INTO edomiProject.editLogicLink (elementid,eingang,linktyp,linkid,ausgang,refresh,value) VALUES (
						'".$copyIds[$t]."',
						'".$n['eingang']."',
						'".$n['linktyp']."',
						".sql_encodeValue($copyIds[$id],true).",
						".sql_encodeValue($n['ausgang'],true).",
						'".$n['refresh']."',
						".sql_encodeValue($n['value'],true)."
					)");
				}

			} else {

				//keine Verbindung vorhanden => Eingang einfach duplizieren
				sql_call("INSERT INTO edomiProject.editLogicLink (elementid,eingang,linktyp,linkid,ausgang,refresh,value) VALUES (
					'".$copyIds[$t]."',
					'".$n['eingang']."',
					'".$n['linktyp']."',
					".sql_encodeValue($n['linkid'],true).",
					".sql_encodeValue($n['ausgang'],true).",
					'".$n['refresh']."',
					".sql_encodeValue($n['value'],true)."
				)");

			}
		}

	}

	return $r;
}

?>