<?
/* 
 * EDOMI beta (Version 1.53) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
//Globale Includes
require("../../shared/php/config.php");
require(MAIN_PATH."/www/shared/php/base.php");
require(MAIN_PATH."/www/shared/php/incl_http.php");

//Eigene Includes
require(MAIN_PATH."/www/visu/include/php/config.php");
require(MAIN_PATH."/www/visu/include/php/base.php");


sql_connect();


$visuCmd=checkVisuSid($visuId,$sid,true);

if ($cmd=='login' || $visuCmd) {
	cmd($cmd,$visuCmd);
} else {
	$ss1=sql_call("SELECT * FROM edomiLive.visu ORDER BY id ASC");
	if ($n=sql_result($ss1)) {
		$html="";
		do {
			$html.="<option value='".$n['id']."' ".(($visuId==$n['id'])?"selected":"").">".ajaxEncode($n['name'])." (".$n['id'].")</option>";
		} while ($n=sql_result($ss1));
?>
		jsLogin("<?echo $visuId;?>","<?echo $html;?>");
<?
	} else {
?>
		serverNotReady("<?echo $visuId;?>");
<?
	}
}


function cmd($cmd,$visuCmd) {
	global $appId,$visuId,$pageId,$data,$dataArr,$phpdata,$phpdataArr,$sid,$vid;

	if ($cmd=='login') {
		$sid=loginVisu($phpdataArr[0],$phpdataArr[1],$phpdataArr[2]);
		if ($sid!==false) {

			if ($phpdataArr[3]=='0') {
				//Standard-Login
?>
				sid="<?echo $sid;?>";
				document.getElementById("login").style.display="none";
				document.getElementById("login").innerHTML="";
				initVisu("<?echo $phpdataArr[0];?>");
<?
			} else {
				//POST-Login mit Reload (damit meta-viewport garantiert akzeptiert wird)
?>
				document.getElementById("loginvisuid").value="<?echo $phpdataArr[0];?>";
				document.getElementById("loginsid").value="<?echo $sid;?>";
				document.getElementById("loginform-post").submit();
<?
			}
			
		} else {
?>
			document.getElementById("login-loginform-fd1").value="";
			document.getElementById("login-loginform-fd2").value="";
			document.getElementById("login-loginform-fd1").focus();
			shakeObj("loginform");
<?
		}
	}
	
	if ($cmd=='initVisu') {
		if ($vid!=global_version) {
?>
			self.location.reload();
<?
			return;
		}
?>
		document.getElementById("windowContainer").style.display="none";
<?
		if (getEdomiStatus()==3) {

			//Visu initialisieren
			$ss1=sql_call("SELECT * FROM edomiLive.visu WHERE (id=".$visuId.")");
			if ($visu=sql_result($ss1)) {

				//Bilder ggf. preloaden
?>
				preload_imagesFile=new Array();
				preload_imagesObj=new Array();
<?

				if (global_visuPreload) {
					$ss2=sql_call("SELECT DISTINCT(bgimgfn) AS imgfn FROM edomiLive.visuPage WHERE (visuid=".$visuId." AND bgimgfn IS NOT NULL AND bgimgfn<>'') UNION SELECT DISTINCT(img) FROM edomiLive.visuElementStyle WHERE (visuid=".$visuId." AND img IS NOT NULL AND img<>'')");
					while ($n=sql_result($ss2)) {
?>
						preload_imagesFile.push("../data/liveproject/visu/img/<?ajaxEcho($n['imgfn']);?>");
<?
					}
				}
				
				//Indikatorfarben holen
				$cssIndiColor1=sql_getValue('edomiLive.visuFGcol','color',"id='".$visu['indicolor']."'");
				if (isEmpty($cssIndiColor1)) {$cssIndiColor1='#80e000';}	//Default: hellgrün
				$cssIndiColor2=sql_getValue('edomiLive.visuFGcol','color',"id='".$visu['indicolor2']."'");
				if (isEmpty($cssIndiColor2)) {$cssIndiColor2='inherit';}	//Default: Vordergrundfarbe des Visuelements nehmen


				//Animationen (CSS) einfügen
?>
				var n="";
<?
				$ss2=sql_call("SELECT DISTINCT(b.id),b.keyframes FROM edomiLive.visuElementStyle AS a,edomiLive.visuAnim AS b WHERE (a.visuid=".$visuId." AND a.anim>0 AND a.anim=b.id)");
				while ($n=sql_result($ss2)) {
?>
					n+="@-webkit-keyframes anim-<?echo $n['id'];?> {<?echo str_replace(chr(10),' ',$n['keyframes']);?>}\n";
<?
				}
				//ShortClick: CSS-Klasse einfügen
?>
				n+=".shortClick{background:<?ajaxValue($cssIndiColor1);?> !important;}";
				document.getElementById("animations").innerHTML=n;
<?

				//Fonts einfügen
?>
				var n="";
<?
				$ss2=sql_call("SELECT * FROM edomiLive.visuFont");
				while ($n=sql_result($ss2)) {
					if ($n['fonttyp']==1) {	//Custom-Font
?>
						n+="@font-face {font-family:'font<?echo $n['id'];?>'; font-style:<?if ($n['fontstyle']==0) {echo 'normal';} else {echo 'italic';}?>; font-weight:<?if ($n['fontweight']==0) {echo 'normal';} else {echo 'bold';}?>; src:url('../../data/liveproject/visu/etc/font-<?echo $n['id'];?>.ttf?<?echo $n['fontname'];?>') format('truetype');}\n";
<?
					} else {				//System-Font
?>
						n+="@font-face {font-family:'font<?echo $n['id'];?>'; src:local('<?ajaxEcho($n['fontname']);?>');}\n";
<?
					}
				}
?>
				document.getElementById("cssFonts").innerHTML=n;
<?

				//Fenster erstellen
?>
				openWindow(<?echo $visu['xsize'];?>,<?echo $visu['ysize'];?>);
<?				
				//Viewport einstellen (iOS)
?>
				document.getElementById("meta-viewport").setAttribute('content','user-scalable=no, width=<?echo $visu['xsize'];?>');
<?
				//Visu-Daten
?>
				var d=document.getElementById("windowContainer");
				visu_indiColor='<?ajaxValue($cssIndiColor1);?>';
				visu_indiColorText='<?ajaxValue($cssIndiColor2);?>';
				visu_visuid=<?echo $visu['id'];?>;
				visu_sspageid=<?echo $visu['sspageid'];?>;
				visu_sstimeout=<?echo $visu['sstimeout'];?>;
				d.style.width="<?echo $visu['xsize'];?>px";
				d.style.height="<?echo $visu['ysize'];?>px";				
				visu_showWarningErr=<?echo ((!global_visuShowErrors)?'-1':'0');?>;
<?
				$n=sql_getValues('edomiLive.visuUser','touch,touchscroll','id='.$visuCmd['targetid']);
				if ($n!==false) {
?>
					visu_touchMode=<?echo $n['touch'];?>;
					visu_allowScrolling=<?echo (($n['touchscroll']==1)?'true':'false');?>;
<?
				}

				//Touch oder Klick? (0=Automatisch, 1=Klick, 2=Touch)
				//Scrolling auf iOS/Touchdevice ggf. verhindern
?>
				downEvent='mousedown';
				moveEvent='mousemove';
				upEvent='mouseup';
				if (visu_touchMode==0 && ('ontouchstart' in window)) {
					downEvent='touchstart';
					moveEvent='touchmove';
					upEvent='touchend';
				} else if (visu_touchMode==1) {
					downEvent='mousedown';
					moveEvent='mousemove';
					upEvent='mouseup';
				} else if (visu_touchMode==2) {
					downEvent='touchstart';
					moveEvent='touchmove';
					upEvent='touchend';
				}

				window.removeEventListener(moveEvent,disableScrolling,false);
				if (!visu_allowScrolling) {
					window.addEventListener(moveEvent,disableScrolling,false);
				}				
<?
				//Soundausgabe ggf. aktivieren
				$tmp=sql_getCount('edomiLive.visuElement',"visuid='".$visuId."' AND controltyp=30");
				$tmp+=sql_getCount('edomiLive.logicCmdList',"(outmode=24 AND outid='".$visuId."') OR (outmode=25 AND outid='".$visuCmd['targetid']."')");
				$tmp+=sql_getCount('edomiLive.visuCmdList',"(outmode=24 AND outid='".$visuId."') OR (outmode=25 AND outid='".$visuCmd['targetid']."')");
				$tmp+=sql_getCount('edomiLive.sequenceList',"(outmode=24 AND outid='".$visuId."') OR (outmode=25 AND outid='".$visuCmd['targetid']."')");
				if ($tmp>0) {
?>
					visu_soundEnabled=1;
					visuSoundInit();
<?
				}

				//TextToSpeech ggf. aktivieren
				$tmp=sql_getCount('edomiLive.visuElement',"visuid='".$visuId."' AND controltyp=31");
				$tmp+=sql_getCount('edomiLive.logicCmdList',"(outmode=26 AND outid='".$visuId."') OR (outmode=27 AND outid='".$visuCmd['targetid']."')");
				$tmp+=sql_getCount('edomiLive.visuCmdList',"(outmode=26 AND outid='".$visuId."') OR (outmode=27 AND outid='".$visuCmd['targetid']."')");
				$tmp+=sql_getCount('edomiLive.sequenceList',"(outmode=26 AND outid='".$visuId."') OR (outmode=27 AND outid='".$visuCmd['targetid']."')");
				if ($tmp>0) {
?>
					visu_textToSpeechEnabled=1;
					visuTextToSpeechInit();
<?
				}

				//Visu-Inititalisierung, Visualarm und Sound zurücksetzen
				sql_call("UPDATE edomiLive.visuUserList SET visuinit=NULL,visupageid=NULL,visusoundid=NULL,visuspeech=NULL WHERE (id='".$visuCmd['id']."')");

				//Websocket starten (=> Visu starten und ggf. Bilder preloaden) 
?>
				visu_startPageId="<?echo $visu['defaultpageid'];?>";
				visu_socket=new class_websocket();
				visu_socket.open(((window.location.protocol=='https:')?'wss':'ws'),window.location.host,<?echo global_visuWebsocketPort;?>);
<?
			} else {
				//VisuId bzw. DB existiert nicht
?>
				serverNotReady(<?echo $visuId;?>);
<?
			}
			
		} else {
			//EDOMI ist nicht bereit
?>
			serverNotReady(<?echo $visuId;?>);
<?
		}
	}
}
?>