/* 
 * EDOMI beta (Version 1.53) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 21 (Diagramm)
//----------------------------

function control21_constructControl(obj,item) {
/*
	var n="<canvas id='e-"+item.id+"-canvas' style='position:absolute; left:0; top:0; width:100%; height:100%;'></canvas>";
	n+="<div id='e-"+item.id+"-reloadanim' class='reloadAnim'></div>";
*/
	var n="<div id='e-"+item.id+"-container' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
		n+="<canvas id='e-"+item.id+"-canvas' style='position:absolute; left:0; top:0; width:100%; height:100%; box-sizing:border-box;'></canvas>";
		n+="<div id='e-"+item.id+"-reloadanim' class='reloadAnim'></div>";
	n+="</div>";
	obj.innerHTML=n;

	obj.dataset.blocked=0;	
	obj.dataset.bufftext=null;	
	obj.dataset.buffkovalue=null;	

	if (obj.dataset.var0==1) {obj.addEventListener(downEvent,function(){if (!checkClick()){return;} visuElementClick(item.id);},false);}
}

function control21_refreshControl(obj,init) {
	if (init || obj.dataset.var7==1) {
		var kovalue=((obj.dataset.live==1)?obj.dataset.livevalue:obj.dataset.value);
		control21_Refresh(obj.dataset.id,pS(obj.dataset.d_text,kovalue),kovalue,false);
	}
}

function control21_Refresh(elementId,chartDateFromTo,koValue,fromBuffer) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (d.dataset.blocked==0 || fromBuffer) {	
			d.dataset.blocked=1;
			
			//Refresh des Charts (Timer wird per Ajax gesetzt)
			if (d.dataset.refreshtimer) {clearTimeout(d.dataset.refreshtimer);}
			document.getElementById("e-"+elementId+"-reloadanim").style.display="inline";
	
			var canvassize=element_getSize(document.getElementById("e-"+elementId+"-canvas"));	
			var n=elementId+AJAX_SEPARATOR1+d.dataset.var1+AJAX_SEPARATOR1+canvassize.w+AJAX_SEPARATOR1+canvassize.h+AJAX_SEPARATOR1+(d.style.fontSize.replace("px",""))+AJAX_SEPARATOR1+chartDateFromTo+AJAX_SEPARATOR1+koValue+AJAX_SEPARATOR1+d.dataset.var3+AJAX_SEPARATOR1+d.dataset.var4+AJAX_SEPARATOR1;
			ajax("chartDraw",1021,visu_visuid,0,n,"");

		} else {
			d.dataset.blocked=2;
			d.dataset.bufftext=chartDateFromTo;	
			d.dataset.buffkovalue=koValue;	
		}
	}
}

//PHP-Callbacks
//----------------------------

function control21_callbackSetTimer(elementId,chartDateFromTo,koValue) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		document.getElementById("e-"+elementId+"-reloadanim").style.display="none";
		if (d.dataset.var2>0 && d.dataset.refreshtimer) {clearTimeout(d.dataset.refreshtimer);}

		if (d.dataset.blocked==1) {
			d.dataset.blocked=0;
			if (d.dataset.var2>0) {d.dataset.refreshtimer=window.setTimeout("control21_Refresh('"+elementId+"','"+stringEscapeSingleQuote(chartDateFromTo)+"','"+stringEscapeSingleQuote(koValue)+"',false);",d.dataset.var2*1000);}
		} else if (d.dataset.blocked==2) {
			d.dataset.blocked=1;
			control21_Refresh(elementId,d.dataset.bufftext,d.dataset.buffkovalue,true);
		}
	}
}

function control21_drawTitel(elementId,chart,yAxisMaxWidth,title,int1,int2) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var canvas=document.getElementById("e-"+elementId+"-canvas");
		if (canvas.getContext) {
			var c=canvas.getContext("2d");

			c.fillStyle=d.style.color;
			c.textBaseline="middle";

			//Start/Enddatum
			if (d.dataset.var3 & 1) {
				c.globalAlpha=d.dataset.var6/100;
	
				c.setLineDash([1,2]);
				c.beginPath();
					c.moveTo(chart[0]+0.5,chart[1]-5);
					c.lineTo(chart[0]+0.5,(chart[3]-chart[1])+5);
					c.moveTo((chart[2]-chart[0])-yAxisMaxWidth+0.5,chart[1]-5);
					c.lineTo((chart[2]-chart[0])-yAxisMaxWidth+0.5,(chart[3]-chart[1])+5);
				c.stroke();
				c.setLineDash([]);
	
				c.textAlign='left';
				c.fillText(int1,chart[0],chart[1]/2);	
				c.textAlign='right';
				c.fillText(int2,(chart[2]-chart[0]),chart[1]/2);
			}

			//Diagramm-Titel
			if ((d.dataset.var3 & 2) && title!="") {
				c.globalAlpha=1;
				c.textAlign="center";
				c.fillText(title,(chart[0]+(chart[2]-chart[0]))/2,chart[1]/2);
			}
		}
	}
}

function control21_drawXaxis(elementId,chart,yAxisMaxWidth,textHeight,points1,points2,title,invert) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var canvas=document.getElementById("e-"+elementId+"-canvas");
		if (canvas.getContext) {
			var c=canvas.getContext("2d");

			c.globalAlpha=d.dataset.var6/100;

			c.lineWidth=1;
			c.shadowOffsetX=0;
			c.shadowOffsetY=0;
			c.shadowBlur=0;
			c.shadowColor="rgba(0,0,0,0)";

			c.strokeStyle=d.style.color;
			c.fillStyle=d.style.color;
			c.textBaseline="middle";

			//Beschriftung: Einheit
			if (d.dataset.var4 & 1) {
				c.textAlign='right';
				c.fillText(title,(chart[2]-chart[0]),(chart[3]-chart[1]/2));
			}

			//Tick-Beschriftung
			var compress=((chart[2]-(2*chart[0])-yAxisMaxWidth)/(points1.length))-2;
			if (d.dataset.var4 & 2) {
				c.textAlign="center";
				c.beginPath();
				for (var t=0;t<points1.length;t++) {
					c.fillText(points1[t].c,parseInt(chart[0]+points1[t].x)+0.5,(chart[3]-chart[1]/2),compress);
				}
				c.stroke();
				
				if (invert) {
					c.save();
						c.globalAlpha=1;
						c.globalCompositeOperation="xor";
						c.fillRect(chart[0],(chart[3]-chart[1]/2)-(textHeight/2)-1,(chart[2]-2*chart[0])-yAxisMaxWidth,textHeight+2);
					c.restore();
				}
			}

			//Ticks
			if (d.dataset.var5 & 1) {
				c.setLineDash([1,2]);
				c.beginPath();
				for (var t=0;t<points1.length;t++) {
					c.moveTo(parseInt(chart[0]+points1[t].x)+0.5,(chart[3]-chart[1])-0);
					c.lineTo(parseInt(chart[0]+points1[t].x)+0.5,(chart[3]-chart[1])+5);
				}
				c.stroke();
				c.setLineDash([]);
			}

			//Trennlinien-Beschriftung
			if (d.dataset.var4 & 4) {
				c.textAlign="left";
				for (var t=0;t<points2.length;t++) {
					c.save();
						c.translate(parseInt(chart[0]+points2[t].x)+0.5,(chart[3]-chart[1])-(textHeight/2));
						c.rotate(-90*Math.PI/180);
						c.fillText(points2[t].c,0,0);
					c.restore();
				}
			}
			
			//Trennlinien
			if (d.dataset.var5 & 2) {
				c.textAlign="left";
				c.setLineDash([1,2]);
				c.beginPath();
				for (var t=0;t<points2.length;t++) {
					if (d.dataset.var4 & 4) {
						c.moveTo(parseInt(chart[0]+points2[t].x)+0.5,chart[1]);
						c.lineTo(parseInt(chart[0]+points2[t].x)+0.5,(chart[3]-chart[1])-c.measureText(points2[t].c).width-textHeight);
					} else {
						c.moveTo(parseInt(chart[0]+points2[t].x)+0.5,chart[1]);
						c.lineTo(parseInt(chart[0]+points2[t].x)+0.5,(chart[3]-chart[1])-(textHeight/2));
					}
				}
				c.stroke();
				c.setLineDash([]);
			}

		}
	}
}

function control21_drawYaxis(elementId,chart,axis) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var canvas=document.getElementById("e-"+elementId+"-canvas");
		if (canvas.getContext) {
			var c=canvas.getContext("2d");

			var ygrids=new Array();
			var yAxisMaxWidth=0;

			for (var id=0;id<axis.length;id++) {
	
				var yfak=(chart[3]-(2*chart[1]))/axis[id].interval[3];

				c.fillStyle=axis[id].style[0];
				c.strokeStyle=axis[id].style[0];
				c.lineWidth=1;
				c.globalAlpha=1;
				c.shadowOffsetX=0;
				c.shadowOffsetY=0;
				c.shadowBlur=0;
				c.shadowColor="rgba(0,0,0,0)";
				c.lineCap="round";
				c.lineJoin="round";		
				c.textAlign="left";
				c.textBaseline="middle";	

				//Y-Ticks: Textbreite ermitteln und merken
				var maxTextWidth=0;
				for (var t=0;t<=axis[id].interval[3];t++) {
					var yValue=axis[id].interval[1]-(t*axis[id].interval[4]);
					var x=c.measureText(parseFloat(yValue.toFixed(2))).width;
					if (x>maxTextWidth) {maxTextWidth=x;}
				}
	
				//Y-Ticks beschriften
				var x=chart[2]-chart[0]-yAxisMaxWidth-maxTextWidth;
				for (var t=0;t<=axis[id].interval[3];t++) {
					var yValue=axis[id].interval[1]-(t*axis[id].interval[4]);
					var y=parseInt(chart[1]+(yfak*t));
					c.fillText(parseFloat(yValue.toFixed(2)),x,y);
					c.beginPath();
						c.moveTo(x+0.5-2-1,y+0.5);
						c.lineTo(x+0.5-2,y+0.5);
					c.stroke();
				}
	
				//Y-Achse zeichnen und beschriften
				c.textAlign="right";
				c.textBaseline="top";
				var x=chart[2]-chart[0]-yAxisMaxWidth-maxTextWidth;
				c.beginPath();
					c.moveTo(x+0.5-2,parseInt(chart[3]-chart[1])+0.5);
					c.lineTo(x+0.5-2,parseInt(chart[1])+0.5);
				c.stroke();
				c.save();
					c.translate(x-axis[id].style[1]-3-2,parseInt(chart[1])-(axis[id].style[1]/4));
					c.rotate(-90*Math.PI/180);
					c.fillText(axis[id].style[2],0,0);
				c.restore();
					
				//Y-Grid zeichnen
				if (axis[id].ygrid[0]>=1) {
					if (axis[id].ygrid[0]==1) {c.strokeStyle=d.style.color;}	
					c.globalAlpha=parseFloat(axis[id].ygrid[1]/100);
					c.setLineDash([1,2]);
					c.beginPath();	
					var x=chart[2]-chart[0]-yAxisMaxWidth-maxTextWidth;
					for (var t=0;t<=axis[id].interval[3];t++) {
						var y=parseInt(chart[1]+(yfak*t));
						if (ygrids.indexOf(y)<0 || axis[id].ygrid[2]==1) {
							c.moveTo(parseInt(chart[0]),y+0.5);
							c.lineTo(x+0.5-2,y+0.5);
							ygrids.push(y);
						}
					}
					c.stroke();
					c.setLineDash([]);
				}
				
				//ggf. currentValue zeichnen
				if (axis[id].style[3]!='') {
					c.strokeStyle=axis[id].style[0];
					c.lineWidth=2;
					c.globalAlpha=1;
					var x=chart[2]-chart[0]-yAxisMaxWidth-maxTextWidth;
					var yValue=parseFloat(axis[id].style[3]);
					var t=(axis[id].interval[1]-yValue.toFixed(2))/axis[id].interval[4];
					var y=chart[1]+(yfak*t);
					c.beginPath();
						c.moveTo(x+0.5-3-(axis[id].style[1]/3),y-(axis[id].style[1]/4));
						c.lineTo(x+0.5-3,y+0.5);
						c.lineTo(x+0.5-3-(axis[id].style[1]/3),y+(axis[id].style[1]/4));
					c.stroke();
				}

				yAxisMaxWidth+=maxTextWidth+axis[id].style[1]+5+2;
			}

			return yAxisMaxWidth;
		}
	}
	return 0;
}

function control21_drawChart(elementId,chartTyp,clustering,showMinMax,chartYmin,chartYmax,style,points) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var canvas=document.getElementById("e-"+elementId+"-canvas");
		if (canvas.getContext) {
			var c=canvas.getContext("2d");

			c.lineCap="round";
			c.lineJoin="round";
			c.fillStyle=style[0];
			c.strokeStyle=style[0];
			c.globalAlpha=style[1];
			c.lineWidth=style[2];
			c.shadowOffsetX=style[3];
			c.shadowOffsetY=style[3];
			c.shadowBlur=style[3];
			c.shadowColor="rgba(0,0,0,0.6)";

			var lineWidth=c.lineWidth;
			var tmax=points.length;
		
			if (tmax<3) {return false;}	//mind. 3 Punkte: Fake(t=0),...Datenpunkte...,Fake(t=max)

			//Linienchart
			if (chartTyp==1 || chartTyp==101) {	
				c.beginPath();
				if (chartTyp==101) {
					c.moveTo(points[0].x+points[0].w,chartYmin);
					c.lineTo(points[0].x+points[0].w,points[0].y);
				} else {
					c.moveTo(points[0].x+points[0].w,points[0].y);
				}
				for (var t=0;t<tmax;t++) {
					c.lineTo(points[t].x+points[t].w,points[t].y);
					drawMinMax(t,points[t].w);
				}
				if (chartTyp==101) {
					c.lineTo(points[tmax-1].x+points[tmax-1].w,chartYmin);
					c.lineTo(points[0].x+points[0].w,chartYmin);
					c.fill();
				} else {
					c.stroke();
				}
			}
			
			//Flankenchart (ohne OffsetX)
			if (chartTyp==2 || chartTyp==102) {	
				c.beginPath();
				if (chartTyp==102) {
					c.moveTo(points[0].x,chartYmin);
					c.lineTo(points[0].x,points[0].y);
				} else {
					c.moveTo(points[0].x,points[0].y);
				}
				for (var t=1;t<tmax;t++) {
					c.lineTo(points[t].x,points[t-1].y);
					c.lineTo(points[t].x,points[t].y);
					drawMinMax(t,points[t].w);
				}
				if (chartTyp==102) {
					c.lineTo(points[tmax-1].x,chartYmin);
					c.lineTo(points[0].x,chartYmin);
					c.fill();
				} else {
					c.stroke();
				}
			}

			//Balkenchart (normal oder Alpha) (ohne OffsetX)
			if (chartTyp==3 || chartTyp==103) {	
				for (var t=1;t<(tmax-1);t++) {
					if (chartTyp==103) {
						c.globalAlpha=((chartYmin-points[t].y)/Math.abs(chartYmax-chartYmin))*style[1];
					}
					if (clustering) {
						//Kummulation
						var xwidth=points[t].w2-0.5;
						if (xwidth<0.5) {xwidth=0.5;}
						c.fillRect(points[t].x-points[t].w2/2,points[t].y,xwidth,chartYmin-points[t].y);
						drawMinMax(t,0);
					} else {
						//Normal
						if (t<(tmax-1)) {var xwidth=(points[t+1].x-points[t].x)-0.5;} else {var xwidth=0.5;}
						if (xwidth<0.5) {xwidth=0.5;}
						c.fillRect(points[t].x,points[t].y,xwidth,chartYmin-points[t].y);
						drawMinMax(t,xwidth/2);
					}
				}
			}

			//Bezierchart (mittelwertig)
			if (chartTyp==4 || chartTyp==104) {	
				c.beginPath();
				if (chartTyp==104) {
					c.moveTo(points[0].x+points[0].w,chartYmin);
					c.lineTo(points[0].x+points[0].w,points[0].y);
				} else {
					c.moveTo(points[0].x+points[0].w,points[0].y);
				}
				for (var t=0;t<(tmax-1);t++) {
					c.quadraticCurveTo(points[t].x+points[t].w,points[t].y,(points[t].x+points[t+1].x)/2+points[t].w,(points[t].y+points[t+1].y)/2);
					drawMinMax(t,points[t].w);
				}
				c.lineTo(points[tmax-1].x+points[tmax-1].w,points[tmax-1].y);
				if (chartTyp==104) {
					c.lineTo(points[tmax-1].x+points[tmax-1].w,chartYmin);
					c.lineTo(points[0].x+points[0].w,chartYmin);
					c.fill();
				} else {
					c.stroke();
				}
			}

			//Punktchart: Kreis
			if (chartTyp==5) {	
				c.lineWidth=lineWidth/2;
				for (var t=1;t<(tmax-1);t++) {
					c.beginPath();
					c.arc(points[t].x+points[t].w,points[t].y,lineWidth/2,0,2*Math.PI,false);
					c.stroke();
					drawMinMax(t,points[t].w);
				}
			}

			//Punktchart: Kreuz
			if (chartTyp==6) {	
				c.lineWidth=lineWidth/2;
				c.beginPath();
				for (var t=1;t<(tmax-1);t++) {
					c.moveTo(points[t].x-(lineWidth/2)+points[t].w,points[t].y-(lineWidth/2));
					c.lineTo(points[t].x+(lineWidth/2)+points[t].w,points[t].y+(lineWidth/2));
					c.moveTo(points[t].x-(lineWidth/2)+points[t].w,points[t].y+(lineWidth/2));
					c.lineTo(points[t].x+(lineWidth/2)+points[t].w,points[t].y-(lineWidth/2));
					drawMinMax(t,points[t].w);
				}
				c.stroke();
			}

			//Punktchart: Strich
			if (chartTyp==7) {	
				c.beginPath();
				for (var t=1;t<(tmax-1);t++) {
					c.moveTo(points[t].x-lineWidth+points[t].w,points[t].y);
					c.lineTo(points[t].x+lineWidth+points[t].w,points[t].y);
					drawMinMax(t,points[t].w);
				}
				c.stroke();
			}

			//Punktchart: Punkt
			if (chartTyp==8) {	
				c.beginPath();
				for (var t=1;t<(tmax-1);t++) {
					c.moveTo(points[t].x-0.0001+points[t].w,points[t].y);
					c.lineTo(points[t].x+0.0001+points[t].w,points[t].y);
					drawMinMax(t,points[t].w);
				}
				c.stroke();
			}

			//Bezierchart
			if (chartTyp==10 || chartTyp==110) {	
				c.beginPath();
				if (chartTyp==110) {
					c.moveTo(points[0].x+points[0].w,chartYmin);
					c.lineTo(points[0].x+points[0].w,points[0].y);
				} else {
					c.moveTo(points[0].x+points[0].w,points[0].y);
				}

				c.lineTo(points[1].x+points[1].w,points[1].y);
				drawMinMax(1,points[1].w);

				for (var t=2;t<(tmax-1);t++) {
					var cp1=getControlpoints(points[t-2].x+points[t-2].w,points[t-2].y,points[t-1].x+points[t-1].w,points[t-1].y,points[t].x+points[t].w,points[t].y);
					var cp2=getControlpoints(points[t-1].x+points[t-1].w,points[t-1].y,points[t].x+points[t].w,points[t].y,points[t+1].x+points[t+1].w,points[t+1].y);
					if (cp1!==false && cp2!=false) {c.bezierCurveTo(cp1.x2,cp1.y2,cp2.x1,cp2.y1,points[t].x+points[t].w,points[t].y);}
					drawMinMax(t,points[t].w);
				}

				c.lineTo(points[tmax-1].x+points[tmax-1].w,points[tmax-1].y);
				if (chartTyp==110) {
					c.lineTo(points[tmax-1].x+points[tmax-1].w,chartYmin);
					c.lineTo(points[0].x+points[0].w,chartYmin);
					c.fill();
				} else {
					c.stroke();
				}
			}

			//Alphafläche (ohne OffsetX)
			if (chartTyp==11) {	
				for (var t=1;t<(tmax-1);t++) {
					c.globalAlpha=((chartYmin-points[t].y)/Math.abs(chartYmax-chartYmin))*style[1];
					if (clustering) {
						//Kummulation
						var xwidth=points[t].w2;
						if (xwidth>0) {
							c.fillRect(points[t].x-points[t].w2/2,chartYmax,xwidth,chartYmin-chartYmax);
						}
					} else {
						//Normal
						if (t<(tmax-1)) {var xwidth=(points[t+1].x-points[t].x)-0;} else {var xwidth=0;}
						if (xwidth>0) {
							c.fillRect(points[t].x,chartYmax,xwidth,chartYmin-chartYmax);
						}
					}
				}
			}

		}
	}
	
	function drawMinMax(t,offsetX) {
		if (showMinMax && points[t].y1!==null && points[t].y2!==null) {
			c.fillRect(offsetX+points[t].x,points[t].y1,1,points[t].y2-points[t].y1);
			c.fillRect(offsetX+points[t].x-lineWidth,points[t].y1-1,lineWidth*2,1);
			c.fillRect(offsetX+points[t].x-lineWidth,points[t].y2-1,lineWidth*2,1);
		}
	}

	function getControlpoints(x1,y1,x2,y2,x3,y3) {
		var tension=0.5;
		var d1=Math.sqrt(Math.pow(x1-x2,2)+Math.pow(y1-y2,2));
		var d2=Math.sqrt(Math.pow(x2-x3,2)+Math.pow(y2-y3,2));
		var d0=d1+d2;
		if (d0==0) {
			return false;
		} else {
			return {x1:(x2-(x3-x1)*tension*d1/d0),y1:(y2-(y3-y1)*tension*d1/d0),x2:(x2+(x3-x1)*tension*d2/d0),y2:(y2+(y3-y1)*tension*d2/d0)};    
		}
	}
}
